#ifndef __CDATASETDESCRIPTION__
#define __CDATASETDESCRIPTION__

#include "../MLPDataset/IDataSet.h"
#include <deque>

using namespace std;

enum DSType { e_CV, e_TEST, e_CVMAKESPLIT};

/**
 * @author Marek Grzes
 */
class CDatasetDescription{
public:
	bool	m_bCostOfAttrs;
	bool	m_bCostOfClassification;
	bool	m_bmakeSplit;
	int		m_iDSID;
	
	/**
	 * 0 - kroswalidacja
	 * 1 - test
	 * 2 - ...
	 */
	int		m_iExperimentType;

	/**
	 * Zbior danych uczacych w przypadku testu, lub danych do podzielenia
	 * i zastosowania do kroswalidacji.
	 */
	IDataSet	*m_ptrainDS;

	/**
	 * Zbior danych tesowych. Jak NULL to nie ma zbioro testowego i wykonywana
	 * jest kroswalidacja.
	 */
	IDataSet	*m_ptestDS;

	/**
	 * Jak wskazniki do zbiorow uczacego i testowego sa NULL to wtedy przeprowadzana
	 * jest kroswalidacja na podziale reprezentowanym przez zbiory danych w 
	 * wektorze m_vpDataSets.
	 */
	deque<const IDataSet*>	m_deqDatasets;

	string		m_sDSFormat;
	string		m_sName;
	string		m_sPath2Stem;
	vector<unsigned>	m_vsCols2Rem;

	/**
	 * This attributes are taken into account only with crossvalidation.
	 */
	bool	m_bStratified;
	int		m_iFolds;

	DSType GetDSType();
	
	/**
	 * Funkcja wczytuje dane z dysku.
	 */
	bool LoadData();
	
	/**
	 * Funkcja zwalnia dane. Ze wzglednow wydajnosciowych lepiej
	 * nie przechowywac wiecej niz jednego wczytanego zbioru danych.
	 */
	void ReleaseData();
	
	CDatasetDescription(void);
	virtual ~CDatasetDescription(void);
};

#endif
