#include "ClassificationExperiment.h"

IClassificationExperiment::IClassificationExperiment(ostream *ostr){
	m_pOutStream=ostr;
}

void IClassificationExperiment::AddXMLParams(TiXmlElement &testElement, IInducer* inducer){
	TiXmlElement MLPParamsElement("MLPParams");
	vector<string> params = inducer->GetParams();
	for(size_t t=0; t+1<params.size(); t+=2){
		TiXmlElement MLPParamElement("MLPParam");
		MLPParamElement.SetAttribute("Name",params[t]);
		MLPParamElement.SetAttribute("Value",params[t+1]);
		vector<string> subparams = inducer->GetSubOptions(params[t],params[t+1]);
		for(size_t s=0; s+1<subparams.size(); s+=2){
			TiXmlElement MLPSubParamElement("MLPSubParam");
			MLPSubParamElement.SetAttribute("Name",subparams[s]);
			MLPSubParamElement.SetAttribute("Value",subparams[s+1]);
			MLPParamElement.InsertEndChild(MLPSubParamElement);
		}
		MLPParamsElement.InsertEndChild(MLPParamElement);
	}
	testElement.InsertEndChild(MLPParamsElement);
}
