#ifndef __ICLASSIFICATIONEXPERIMENTH__
#define __ICLASSIFICATIONEXPERIMENTH__ 

#include "../tinyxml/tinyxml.h"
#include "Classifier.h"
#include "Inducer.h"

#include <iostream>
#include <vector>

using namespace std;

/**
 * Interfejs eksperymentu.
 * @author Marek Grzes'
 */
class IClassificationExperiment{
protected:
	/**
	 * Wskaznik do strumienia, do ktorego ma byc drukowany wynik eksperymentu.
	 */
	ostream *m_pOutStream;

public:

	virtual bool RunTestXML(TiXmlElement &xmlElement, string outputFolder, string filestem, const IDataSet *trainDS, IInducer* inducer, const IDataSet *testDS=NULL)=0;
	virtual bool RunTestXML(TiXmlElement &xmlElement, string outputFolder, string filestem, deque<const IDataSet*> deqtrainDS, IInducer* inducer, const IDataSet *testDS=NULL)=0;

	IClassificationExperiment(ostream *ostr);
	virtual ~IClassificationExperiment(){
	}

protected:
	/**
	 * Medota wstawia tag MLPParams jako child przekazanego w parametrze tag'a.
	 */
	virtual void AddXMLParams(TiXmlElement &testElement, IInducer* inducer);
	
};

#endif


