#include "ConstClassifier.h"
#include <typeinfo>

CConstClassifier::CConstClassifier(const IDataSet* dataset,bool bCostOfClassification):IClassifier(dataset,bCostOfClassification,false){
	assert(dataset);
	m_pIAMajorityClass = NULL;
}

CConstClassifier::~CConstClassifier(void){
	if(m_pIAMajorityClass)
		delete m_pIAMajorityClass;
}

string CConstClassifier::GetClassifierName(){
	return "Const classifier";
}	

IAttrValue* CConstClassifier::Classify(CDataObject *instance){
	if(m_pIAMajorityClass==NULL){
			CLogger::LogError("Constant Classifier not initialized.",__FILE__,__LINE__);
	}
	return m_pIAMajorityClass;
}

IAttrValue* CConstClassifier::Classify(CDataObject *instance, pair<double,double> &cost){
	// Koszt atrybutow jest tu pomijany (czyli zero)
	cost.second = 0;
	if(m_bCostOfClassification){
		try{
			CNomAttr& predC = dynamic_cast<CNomAttr&>(*m_pIAMajorityClass);
			CNomAttr& trueC = dynamic_cast<CNomAttr&>(*(instance->GetClass()));
			cost.first = m_pIDataset->CostOfClassification(predC,trueC);
			}
		catch(bad_cast){
		}
	}else{
		cost.first=0;
	}
	return m_pIAMajorityClass;
}

void CConstClassifier::DisplayStruct(ostream &ostr, int dispformat){
	ostr<<"_______________________________________________________________"<<endl;
	ostr<<"Const classifier:"<<endl;
	ostr<<"_______________________________________________________________"<<endl;
	ostr<<"Majority class: ";
	m_pIAMajorityClass->PrintValue(ostr);
	ostr<<endl;
	ostr<<"_______________________________________________________________"<<endl;
}

unsigned CConstClassifier::GetClassifierSize(int iResType)const{
	return 1;
}
