#include "ConstInducer.h"
#include "ConstClassifier.h"
#include "../MLPDataset/NomAttr.h"
#include "../MLPDataset/RealAttr.h"

#include <iomanip>

CConstInducer::CConstInducer(){
}

IClassifier *CConstInducer::ActualTrain(const IDataSet *trainingDataSet){
CConstClassifier *res = new CConstClassifier(trainingDataSet,m_bCostOfClassification);
vector<sCounter*> vs;

	for(unsigned int i=0;i<trainingDataSet->GetSize();i++){
		CDataObject *inst = (*trainingDataSet)[i];
		int x=0;
		for(unsigned int j=0;j<vs.size();j++){
			IAttrValue *ia1=vs[j]->s_pIAttrValue;
			IAttrValue *ia2=inst->GetClass();
			if((*ia1)==(*ia2)){
				vs[j]->s_Counter++;
				x=1;
				break;
			}
		}
		if(x==0){
			sCounter *t=new sCounter;
			t->s_Counter=1;
			t->s_pIAttrValue=inst->GetClass();
			vs.insert(vs.end(),t);
		}
	}

	int max = 0;
	IAttrValue* pmaxClass=NULL;
	for(unsigned int i=0;i<vs.size();i++){
		if(vs[i]->s_Counter>max){
			max = vs[i]->s_Counter;
			pmaxClass = vs[i]->s_pIAttrValue;
		}
	}
	if(pmaxClass==NULL){
		res->m_pIAMajorityClass = NULL;
		return res;
	}
	if(pmaxClass->GetAttrType() == e_NominalAttr)
	{
		res->m_pIAMajorityClass = new CNomAttr((CNomAttr&)*pmaxClass);
	}
	else{
		res->m_pIAMajorityClass = new CRealAttr((CRealAttr&)*pmaxClass);
	}
	return res;
}

bool CConstInducer::SetParam(string sParamName, string sParamValue){
	return false;
}

void CConstInducer::PrintParamsXML(ostream &ostr, int nsp){
	ostr.fill(' ');
	ostr<<setw(nsp)<<" "<<"<!-- MajorityClass classfier doesn't have any params at present -->"<<endl;
	ostr.fill(' ');
}

vector<string> CConstInducer::GetParams() const{
	vector<string> res;
	return res;
}


string CConstInducer::GetName(){
	string ret;
	ret="CONST";
	return ret;
}

