#ifndef __TESTCLASSIFICATIONEXPERIMENTH__
#define __TESTCLASSIFICATIONEXPERIMENTH__

#include "../tinyxml/tinyxml.h"
#include "ClassificationExperiment.h"

/**
 * Eksperyment uczenia klasyfikatora na zbiorze uczacym i testowanie na 
 * oddzielnym zbiorze testowym.
 * @author Marek Grzes'
 */
class CTestClassificationExperiment: public IClassificationExperiment{
public:
	/**
	 * Przeprowadza test bazujac na zbiorze uczacym trainDS, oraz
	 * algorytmnie indukcyjnego ucznia, ktry jest zaimplementowany
	 * w klasie podanej w parametrze inducer.
	 * @param trainDS - zbir uczacy
	 * @param inducer - uczen
	 * @param testDS - zbir testowy
	 * @return true - kiedy poprawne zaknczenie dzialania funkcji
	 */
	virtual bool RunTestXML(TiXmlElement &testElement, string outputFolder, string filestem, const IDataSet *trainDS, IInducer* inducer, const IDataSet *testDS=NULL);
	
	/**
	 * Metoda nie jest implementowana w tej klasie. Jej wywolanie powoduje blad.
	 */
	virtual bool RunTestXML(TiXmlElement &testElement, string outputFolder, string filestem, deque<const IDataSet*> deqtrainDS, IInducer* inducer, const IDataSet *testDS=NULL);

	/**
	 * Konstruktor pobierajacy strumien, ktry przekazywany jest do konstruktora
	 * IClassificationExperiment.
	 * @see IClassificationExperiment#m_pOutStream
	 */
	CTestClassificationExperiment(ostream *ostr=&cout):IClassificationExperiment(ostr){}
	virtual ~CTestClassificationExperiment(){
	}
};

#endif

