#include "MLPStatistics.h"
#include <cstdlib>
#include <iostream>
#include <cmath>

using namespace std;

CMLPStatistics::CMLPStatistics(void){
}

CMLPStatistics::~CMLPStatistics(void){
}

double CMLPStatistics::UCF(double E, double N){
	long double A;
	long double B;
	long double C;

	long double quartile = 1.15; // U(1-alfa/2); alfa=0.25

	A = N / ( N + pow(quartile,2) );
	B = E / N + pow(quartile,2) / (2*N);
	C = 1 / N * sqrt( E*(N-E)/N + pow(quartile,2)/4 ) * quartile;

	return (double) A*(B+C);
}

bool CMLPStatistics::Event(int percent){
		/* W ponizszy sposob bedzie zwrocona losowa liczba w zakresie: [1,n]
		 * Opis w: man rand
		 */
		int n = 100;
		int l = (int)(1.0 + (double)n * (double)rand() / ((double)RAND_MAX+1.0));
		if( (percent) >= l){
			return true;
		}
		return false;
}

int CMLPStatistics::RandVal(int max){
	return (int)((double)max * (double)rand() / ((double)RAND_MAX+1.0));
}

double CMLPStatistics::Rand_01(){
	return (double) ( (1.0 + (double)rand()) /((double)RAND_MAX+1.0) );
}


