#include "OutFormat.h"
#include <iomanip>
#include <algorithm>
#include "Logger.h"
#include <string>

bool StringLess(string str1, string str2){
	return str1.length() < str2.length();
}

COutFormat::COutFormat(void){
}

COutFormat::~COutFormat(void){
}

void COutFormat::PrintHorizontalLine(vector<streamsize> lcell, ostream &ostr){
	ostr.fill('-');
	for(size_t t=0; t<lcell.size(); t++){
		if(t==0)
			ostr<<"+"<<setw(lcell[t])<<""<<"+";
		else
            ostr<<setw(lcell[t])<<""<<"+";
	}
	ostr<<endl;
	ostr.fill(' ');
}

void COutFormat::PrintTable(vector<vector<string> > data, ostream &ostr){
	// data - pierwszy wymiar po kolumnach drugi po wierszach
	// jest tak dlatego, bo wtedy latwiej wyszukac maksymalna szerokosc kolumny
	ostr.setf(ios::left);
	ostr.setf(ios::showpoint);
	ostr.precision(6);

	size_t ncols = data.size();
	size_t nrows;
	if(!data.empty())
		nrows = data.front().size();
	else{
		CLogger::LogError("Inconsistent data",__FILE__,__LINE__);
		return;
	}
	
	vector<streamsize> maxlcell(ncols);
	for(size_t t=0; t<ncols; t++){
		vector<string>::iterator m = max_element(data[t].begin(),data[t].end(),StringLess);
		maxlcell[t] = (streamsize)((*m).length() + 3);
	}

	PrintHorizontalLine(maxlcell,ostr);
	for(size_t r=0; r<nrows; r++){
		for(size_t t=0; t<ncols; t++){
			string str = data[t][r];
			if(t==0)
				ostr<<"|"<<setw(maxlcell[t])<<str.c_str()<<"|";
			else
				ostr<<setw(maxlcell[t])<<str.c_str()<<"|";
		}
		ostr<<endl;
	PrintHorizontalLine(maxlcell,ostr);
	}
}
