#ifndef __COUTFORMAT__
#define __COUTFORMAT__

#include <iostream>
#include <vector>
#include <string>

using namespace std;

/** Klasa do formatowania wyników wyprowadzanych do strumieni.
 * @author Marek Grze
 */
class COutFormat
{
protected:
	/** Drukuje pozimš linię w formatowanej tabeli.
	 * @param lcell - wektor szerokoci poszczególnych komórek tabeli.
	 */
	static void PrintHorizontalLine(vector<streamsize> lcell, ostream &ostr=cout);

public:
	/** Drukuje tabelę danych.
	 * @param data - macierz danych typu string. Pierwszy indeks macierzy
	 * przebiega po kolumnach wyprowadzanych na ekran. Drugi indeks przebiega
	 * po wierszach.
	 * Dane muszš być kompletne, tzn. wszystkie komórki w prostokštnej macierzy
	 * muszš być wypełnione.
	 */
	static void PrintTable(vector<vector<string> > data, ostream &ostr=cout);

	COutFormat(void);
	~COutFormat(void);
};

#endif
