#ifndef __CENTROPYH__
#define __CENTROPYH__

#include "../MLPDataset/DataObject.h"
#include "ITest.h"

/** Klasa dla wylicze entropii i wspczynnika przyrostu inforamcji.
 * @author Marek Grze
 */
class CEntropy
{
public:
	/** Measures the average amount of information needed to indetify the class
	 * of a case in deqCI (known as entropy of the set deqCI).
	 */
	static long double Entropy(deque<CDataObject*> &deqCI);

	/** Oblicza przyrost informacji. 
	 */
	static long double Gain(deque<CDataObject*> &deqCI, ITest *pIT);

	/** Oblicza wspczynnik przyrostu informacji.
	 */
	static long double GainRatio(deque<CDataObject*> &deqCI, ITest *pIT);

	CEntropy(void);
	~CEntropy(void);
};

#endif

