#ifndef __IDTINDUCERH__
#define __IDTINDUCERH__

#include "../MLPClassification/Inducer.h"
#include "DTreeNode.h"
#include "ITestContainer.h"

/**
 * Interfejs, ktorego implementacje sluza do tworzenia drzew decyzyjnych.
 * @author Marek Grzes'
 */
class IDTInducer: public IInducer{
friend class IDTInducerAP;
public:
	virtual bool SetParam(string sParamName, string sParamValue);
	virtual void PrintParamsXML(ostream &ostr, int nsp);
	virtual vector<string> GetParams() const;

	IDTInducer(void);
	virtual ~IDTInducer(void);

protected:
	/**
	 * Sposob pomiaru bledu.
	 * 0 - blad pesymistyczny
	 * 1 - blad na zbiorze uczacym
	 */
	int	m_iError;

	/**
	 * Metoda znajduje klase wiekszosciowa dla podanego zbioru instanncji.
	 * Jezeli podany w parametrze zbior przykladow jest pusty, to jako
	 * wynik zwracany jest wskaznik do klasy przekazanej w drugim parametrze.
	 * 
	 * Kiedy uwzgledniany jest blad blednej klasyfikacji, to wybor klasy
	 * jest na podstawie optymalizacji kosztu.
	 * 
	 * @see m_bCostOfClassification
	 *
	 * @return klasa wiekszosciowa dla przekazanego zbioru danych
	 */
	virtual IAttrValue* Category(const IDataSet* dataset, deque<CDataObject*> &deqCI, IAttrValue *pIA);

	/**
	 * Tworzy lisc drzewa decyzyjnego pokrywajacy zbior set i z klasa
	 * przodka ia.
	 */
	virtual CDTreeNode* MakeTreeLeaf(const IDataSet* dataset, deque<CDataObject*> &set, IAttrValue* ia);

};

#endif

