#ifndef __ITESTH__
#define __ITESTH__

#include "../MLPDataset/IDataSet.h"
#include <string>
#include <deque>
#include <cassert>

/**
 * Interfejs testu.
 * @author Marek Grze
 */
class ITest{

public:
	/**
	 * Zwraca index atrybutu, ktorego dotyczy test. Dla testow
	 * wielowymiarowych powinne byc zwracane -1.
	 */
	virtual int GetAttrNum()const{
		return m_iAttrNum;
	}

	virtual unsigned GetSubSetCount()const=0;
	virtual vector<vector<unsigned> > GetSubSets(deque<CDataObject*> deqCI)const=0;

	/**
	 * Operator do porownywania testow.
	 */
	virtual bool operator==(const ITest& it)const=0;

	/**
	 * Operator do porownywania testow.
	 */
	virtual bool operator<(const ITest& it)const=0;

	/**
	 * Operator do porownywania testow.
	 */
	virtual bool operator>(const ITest& it)const=0;

	/**
	 * Zwraca koszt atrybutw uzytych w danym tescie.
	 */
	virtual float GetCostOfAttributes(const IDataSet* dataset)const=0;
	
	/**
	 * Zwraca koszt atrybutow uzytych w danym tescie, dla ktorych
	 * vUsed[attrNum]==false. Jesli jakis atrybut zostaje tu zliczony to
	 * vUsed[attrNum]=true.
	 */
	virtual float GetCostOfAttributes(const IDataSet* dataset, vector<bool> &vUsed)const=0;


	virtual unsigned GetBranchID(CDataObject *pCInst)const=0;
	virtual void PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const=0;
	virtual ITest* CloneTest()const=0;

	ITest(int attrNum);
	virtual ~ITest(void);

protected:
	/**
	 * Attribute number for single test. Tan numer nie uwzglednia
	 * wektora potrojnego indeksowania jaki jest dla testow CObliqueTest
	 */
	int m_iAttrNum;
};

#endif

