#include "NominalTest.h"
#include <typeinfo>

CNominalTest::CNominalTest(CAttrDesc* pAttrDesc, int attrNum):ITest(attrNum){
	m_pAttrDesc = pAttrDesc;
}

CNominalTest::~CNominalTest(void){
}

CNominalTest::CNominalTest(const CNominalTest& templ):ITest(templ.m_iAttrNum){
	assert(templ.m_pAttrDesc);
	this->m_pAttrDesc = templ.m_pAttrDesc;
}

inline float CNominalTest::GetCostOfAttributes(const IDataSet* dataset)const{
	return m_pAttrDesc->m_fCost;
}

float CNominalTest::GetCostOfAttributes(const IDataSet* dataset, vector<bool> &vUsed)const{
	if(vUsed[m_iAttrNum]){
		return 0;
	}else{
		vUsed[m_iAttrNum]=true;
		return dataset->GetCostOfAttribute(m_iAttrNum);
	}
}

vector<vector<unsigned> > CNominalTest::GetSubSets(deque<CDataObject*> deqCI)const{
vector<vector<unsigned> > res(m_pAttrDesc->m_vAttrDomain.size());
	for(unsigned i=0; i<deqCI.size(); i++){
		unsigned uSubSetId = GetBranchID(deqCI[i]);
		res[uSubSetId].push_back(i);
	}
	return res;	
}

string CNominalTest::ValueToName(unsigned uIndex)const{
	assert(m_pAttrDesc);
	assert(m_pAttrDesc->m_vAttrDomain.size()>uIndex);
	return m_pAttrDesc->m_vAttrDomain[uIndex];
}

bool CNominalTest::operator==(const ITest& it)const{
   try {
		CNominalTest& ref_nomout = dynamic_cast<CNominalTest&>((ITest&)it);
		if(ref_nomout.m_iAttrNum == m_iAttrNum){
			return true;
		}
		return false;
   }
   catch (bad_cast) {
      return false;
   }
}

void CNominalTest::PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const{
	assert(m_pAttrDesc);
	assert(m_pAttrDesc->m_vAttrDomain.size()>branchid);
	ostr<<m_pAttrDesc->m_sAtrrName<<" = "<<branchid<<" ("<<m_pAttrDesc->m_vAttrDomain[branchid]<<")";
}
