#ifndef __CNOMINALTESTH__
#define __CNOMINALTESTH__

#include "ITest.h"
#include "../MLPDataset/AttrDesc.h"
#include "../MLPDataset/NomAttr.h"

/**
 * Test na trybucie nominalnym.
 * @author Marek Grzes'
 */
class CNominalTest : public ITest{
public:
	/**
	 * Zwraca nazwe wartosci nominalnej, odpowiadajacej wartosci uIndex.
	 */
	virtual string ValueToName(unsigned uIndex)const;
	
	virtual float GetCostOfAttributes(const IDataSet* dataset)const;
	virtual float GetCostOfAttributes(const IDataSet* dataset, vector<bool> &vUsed)const;
	virtual vector<vector<unsigned> > GetSubSets(deque<CDataObject*> deqCI)const;

	virtual unsigned GetSubSetCount()const{
		return (unsigned)(m_pAttrDesc->m_vAttrDomain.size());
	}
	virtual unsigned GetBranchID(CDataObject *pCInst)const{
		assert(pCInst);
		IAttrValue* pIA1 = (*pCInst)[m_iAttrNum];
		assert(pIA1);
		CNomAttr* ref_nomattr = dynamic_cast<CNomAttr*>(pIA1);
		assert(ref_nomattr);
		size_t ret = ref_nomattr->m_AttrValue.u_iNom;
		if(ret<0 || ret>=m_pAttrDesc->m_vAttrDomain.size()){
			CLogger::LogError("Index out of scope",__FILE__,__LINE__);
			return 0;
		}
		// Wartosc nominalna jest numerem galezi.
		return (unsigned)ret;
	}
	virtual ITest* CloneTest()const{
		CNominalTest* temp = new CNominalTest(*this);
		return (ITest*) temp;
	}
	virtual bool operator==(const ITest& it)const;
	virtual bool operator<(const ITest& it)const{
		return false;
	}
	virtual bool operator>(const ITest& it)const{
		return false;
	}
	virtual void PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const;

	CNominalTest(CAttrDesc* pAttrDesc, int iAttrNum);
	CNominalTest(const CNominalTest& templ);
	virtual ~CNominalTest(void);

protected:
	CAttrDesc* m_pAttrDesc;

};

#endif
