/**
 * $Revision: 1.4 $
 * $Date: 2006/05/23 13:04:52 $
 */

#ifndef __CNOMINALTESTINNERDISJH__
#define __CNOMINALTESTINNERDISJH__

#include "NominalTest.h"

/**
 * Test na trybucie nominalnym z wewnetrzna dyzjunkcja.
 * @author Marek Grzes'
 */
class CNominalTestInnerDisj : public CNominalTest{
public:
	/**
	 * Wektor, ktory odwzorowuje index wartosci nominalnej atrybutu na index galezi
	 * (podwojne indeksowanie).
	 */
	vector<size_t>	m_vtInnerDisIndex;

	/**
	 * Zwraca nazwy wartosci nominalnych, odpowiadajacych galezi o indeksie uIndex.
	 * @param uIndex - indeks galezi, dla ktorej zwracane sa nazwy wartowci atrybutu nominalnego,
	 * ktore odpowiadaja tej galezi
	 */
	virtual string ValueToName(unsigned uIndex)const;

	virtual vector<vector<unsigned> > GetSubSets(deque<CDataObject*> deqCI)const;
	
	/**
	 * W tej implementacji testu, metoda ta ma zwrocic liczbe roznych wartoci w wektorze
	 * m_vtInnerDisIndex.
	 * @see m_vtInnerDisIndex
	 */
	virtual unsigned GetSubSetCount()const;
	
	inline virtual unsigned GetBranchID(CDataObject *pCInst)const;
	
	virtual ITest* CloneTest()const{
		CNominalTestInnerDisj* temp = new CNominalTestInnerDisj(*this);
		return (ITest*) temp;
	}
	virtual bool operator==(const ITest& it)const;
	virtual bool operator<(const ITest& it)const{
		return false;
	}
	virtual bool operator>(const ITest& it)const{
		return false;
	}
	virtual void PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const;
	
	/**
	 * Metoda resetuje wartosci w wektorze m_vtInnerDisIndex i ustawia je losowo tak,
	 * zeby test dawal n wyjsc.
	 * @param nSubSets - docelowa liczba wyjsc
	 * @param true - kiedy operacja zakonczyla sie powodzeniem
	 */
	virtual bool SetSubSets(size_t nSubSets);
	
	CNominalTestInnerDisj(CAttrDesc* pAttrDesc, int iAttrNum);
	CNominalTestInnerDisj(const CNominalTestInnerDisj& templ);
	virtual ~CNominalTestInnerDisj(void);
	
};

#endif
