#ifndef __CREALTESTH__
#define __CREALTESTH__

#include "ITest.h"
#include "ITestContainer.h"

/** Test na atrybucie rzeczywistym.
 * @author Marek Grzes'
 */
class CRealTest : public ITest
{
public:
	double	m_dThreshold;
	
	virtual float GetCostOfAttributes(const IDataSet* dataset)const;
	virtual float GetCostOfAttributes(const IDataSet* dataset, vector<bool> &vUsed)const;
	
	virtual unsigned GetSubSetCount()const{
		return (unsigned)2;
	}
	virtual vector<vector<unsigned> > GetSubSets(deque<CDataObject*> deqCI)const;
	virtual unsigned GetBranchID(CDataObject *pCInst)const;
	virtual bool operator==(const ITest& it)const;
	virtual bool operator<(const ITest& it)const;
	virtual bool operator>(const ITest& it)const;
	virtual void PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const;
	virtual ITest* CloneTest()const{
		CRealTest* temp = new CRealTest(*this);
		return (ITest*) temp;
	}

	CRealTest(const CRealTest& templ);
	CRealTest(double threshold, int attrNum);
	virtual ~CRealTest(void);

protected:	

};

#endif

