#include "TestCreator.h"

bool CTestCreator::FindMixedDipol(deque<CDataObject*> &deqCI, CDataObject* &ob1, CDataObject* &ob2){
	bool found=false;
	if(deqCI.size()>0){
		IAttrValue *pIA1 = deqCI[0]->GetClass();
		for(unsigned i=1; i<deqCI.size(); i++){
			IAttrValue *pIA2 = deqCI[i]->GetClass();
			if( ! ((*pIA1) == (*pIA2)) ){
				found=true;
				break;
			}
		}
	}else{
		return false;
	}
	if(!found){
		return false;
	}
	vector<vector<CDataObject*> > splitCI(1);
	splitCI[0].push_back(deqCI[0]);
	for(size_t t=1; t<deqCI.size(); t++){
		bool found = false;
		for(size_t k=0; k<splitCI.size(); k++){
			if( *(splitCI[k].front()->GetClass()) == *(deqCI[t]->GetClass()) ){
				splitCI[k].push_back(deqCI[t]);
				found=true;
				break;
			}
		}
		if(!found){
			splitCI.resize(splitCI.size()+1);
			splitCI[splitCI.size()-1].push_back(deqCI[t]);
		}
	}
	if(!(splitCI.size()>(size_t)1)){
		return false;
	}
	size_t atrind1 = rand()%splitCI.size();
	size_t ind1 = rand()%splitCI[atrind1].size();
	size_t atrind2 = rand()%splitCI.size();
	while(atrind1 == atrind2){
		atrind2 = rand()%splitCI.size();
	}
	size_t ind2 = rand()%splitCI[atrind2].size();
	ob1 = splitCI[atrind1][ind1];
	ob2 = splitCI[atrind2][ind2];
	return true;
}

bool CTestCreator::FindMixedDipol(deque<CDataObject*> &deqCI, CDataObject* &ob1, CDataObject* &ob2, ITest* pITest){
	CObliqueTest* oblTest = dynamic_cast<CObliqueTest*>(pITest);
	assert(oblTest);

	bool found=false;
	if(deqCI.size()>0){
		IAttrValue *pIA1 = deqCI[0]->GetClass();
		for(unsigned i=1; i<deqCI.size(); i++){
			IAttrValue *pIA2 = deqCI[i]->GetClass();
			if( ! ((*pIA1) == (*pIA2)) ){
				found=true;
				break;
			}
		}
	}else{
		return false;
	}
	if(!found){
		return false;
	}
	vector<vector<CDataObject*> > splitCI(1);
	splitCI[0].push_back(deqCI[0]);
	for(size_t t=1; t<deqCI.size(); t++){
		bool found = false;
		for(size_t k=0; k<splitCI.size(); k++){
			if( *(splitCI[k].front()->GetClass()) == *(deqCI[t]->GetClass()) ){
				splitCI[k].push_back(deqCI[t]);
				found=true;
				break;
			}
		}
		if(!found){
			splitCI.resize(splitCI.size()+1);
			splitCI[splitCI.size()-1].push_back(deqCI[t]);
		}
	}
	if(!(splitCI.size()>(size_t)1)){
		return false;
	}
	size_t atrind1 = rand()%splitCI.size();
	size_t atrind2 = rand()%splitCI.size();
	while(atrind1 == atrind2){
		atrind2 = rand()%splitCI.size();
	}
	// Pierwszy losujemy
	size_t ind1 = rand()%splitCI[atrind1].size();
	double ip1 = oblTest->GetInnerProduct(splitCI[atrind1][ind1]);
	// wyrzucamy z splitCI te, ktore leza po drugiej stronie hip. zeby
	// z nich nie losowac.
	vector<CDataObject*>::iterator iter = splitCI[atrind2].begin();
	while(iter<splitCI[atrind2].end()){
		if(ip1*oblTest->GetInnerProduct(*iter)<0){
			splitCI[atrind2].erase(iter);
		}
		iter++;
	}
	if(splitCI[atrind2].empty()){
		return false;
	}

	// I tu juz losowanie z innej klasy, ale lezacego tej samej stronie hip.
	size_t ind2 = rand()%splitCI[atrind2].size();

	ob1 = splitCI[atrind1][ind1];
	ob2 = splitCI[atrind2][ind2];
	return true;
}

