#ifndef __CTESTCREATORH__
#define __CTESTCREATORH__

#include "../MLPDataset/DataObject.h"
#include "../MLPDT/ObliqueTest.h"
#include <deque>

/**
 * Klasa podstawowa dla klas tworzacych testy.
 * @author Marek Grzes'
 */
class CTestCreator{

public:
	virtual ~CTestCreator(){}
	
	/**
	 * Znajduje mieszany dipol.
	 * @return false kiedy dane sa tylko z jednej klasy.
	 */
	virtual bool FindMixedDipol(deque<CDataObject*> &deqCI, CDataObject* &ob1, CDataObject* &ob2);

	/**
	 * Znajduje mieszany dipol, ktory jest nie jest przecinany przez hiperplaszczyzne
	 * testu.
	 * @return false kiedy dane sa tylko z jednej klasy.
	 *
	 * UWAGA: Traci to sens kiedy sa wiecej niz dwie klasy??
	 */
	virtual bool FindMixedDipol(deque<CDataObject*> &deqCI, CDataObject* &ob1, CDataObject* &ob2, ITest* pITest);
	
};

#endif

