/**
 * $Revision: 1.12 $
 * $Date: 2005/04/16 12:29:20 $
 */

#ifndef __CTDIDTINDUCERH__
#define __CTDIDTINDUCERH__

#include "../MLPDT/IDTInducerAP.h"
#include "../MLPDT/ITDIDTInducer.h"

/**
 * Uczen generujacy drzewo decyzyjne stosujac TDIDT.
 * @author Marek Grzes'
 */
class CTDIDTInducer: public ITDIDTInducer, public IDTInducerAP{

public:
	virtual vector<string> GetParams() const;
	virtual bool SetParam(string sParamName, string sParamValue);
	virtual void PrintParamsXML(ostream &ostr, int nsp);
	virtual string GetName();
	virtual ITest* PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);

	CTDIDTInducer();
	virtual ~CTDIDTInducer();

protected:
	/**
	 * Sposob oceny testow.
	 *	gain criterion
	 *	gain ratio criterion
	 *  none
	 */
	string m_sSelectionOfATest;

	/**
	 * Przeprowadza losowa wewnetrzna dyzjunkcje na testcie.
	 * @see CNominalTestInnerDisj#SetSubSets	 
	 */
	virtual void RandomInnerDisjuntion(ITest* pTest);

	/**
	 * Metoda wywolywana przed uruchomieniem funkcji rekurenyjnej majaca
	 * na celu utworzenie testow ITest. 
	 */
	virtual void PreBuildTree(ITestContainer &tests, const IDataSet *trainingDataSet);

	/**
	 * Metoda wywolywana po zakonczeniu rekurencyjnego budowania drzewa.
	 * Zwalnia pamiec zajmowana przez testy ITest.
	 */
	virtual void PostBuildTree(ITestContainer &tests);
};

#endif

