#ifndef __CTDIDTRANDINDUCER__
#define __CTDIDTRANDINDUCER__

#include "TDIDTInducer.h"

/**
 * Uczen, ktory tworzy drzewo decyzyjne z wykorzystniem TDIDT wybierajac
 * testy w sposob losowy. Powtarza on n razy TDIDT z losowym wyborem testu
 * i zwraca najlepsze drzewo uzyskane w n eksperymentach.
 * @author Marek Grzes'
 */
class CTDIDTRandInducer : public CTDIDTInducer
{
public:
	virtual vector<string> GetParams() const;
	virtual bool SetParam(string sParamName, string sParamValue);
	virtual void PrintParamsXML(ostream &ostr, int nsp);
	virtual string GetName();

	CTDIDTRandInducer(void);
	virtual ~CTDIDTRandInducer(void);

protected:
	unsigned m_uNumberOfIterations;

private:
	virtual IClassifier *ActualTrain(const IDataSet *trainingDataSet);
};

#endif
