#ifndef __CATTRDESCH__
#define __CATTRDESCH__

#include "../MLPCommon/common.h"
#include <string>
#include <vector>

using namespace std;

/**
 * Klasa stanowi opis pojedynczego atrybutu zarowno nominalnego jak i ciaglego.
 * @author Marek Grzes'
 */
class CAttrDesc{
public:

	/**
	 * Nazwa atrybutu.
	 */
	string m_sAtrrName;

	/**
	 * Rodzaj atrybutu.
	 * 0 - nominalny
	 * 1 - ciagly
	 * @see CNomAttr
	 * @see CRealAttr
	 */
	int m_iContinuous;
	
	/**
	 * Koszt pozyskania atrybutu.
	 */
	float m_fCost;

	
	/**
	 * Wektor z wartosciami dziedziny atrybutu nominalnego.
	 * @see GetPos()
	 * @see SetPos()
	 */
	vector<string> m_vAttrDomain;

	/**
	 * Fukcja zwraca liczbe odpowiadajaca atrybutowi nominanemu
	 * o wartosci zadanej parametrem str. Liczba ta jest indeksem pod jakim atrybut
	 * ten wystepuje w wektorze m_vAttrDomain.
	 * @param str - lancuch znakow stanowiacy nazwe wartosci nominalnej.
     * @return reprezentacja numeryczna podanej w postaci lancucha znakow wartosci
     * @return -1 w przypakdu bledu 
	 * @see m_vAttrDomain
	 */
	int GetPos(const char *str) const;

	/** Funkcja dodaje do wektora m_vAttrDomain kolejna wartosc nominalna.
	 * @param str - lancuch znakow stanowiacy nazwe wartosci nominalnej
	 * @return pozycja, na ktorej dodano wartosc
	 * @return -1 kiedy wartosc jest juz w mektorze m_vAttrDomain
	 */
	int AddDomainElement(char *str);

	/**
	 * Konstruktor.
	 */
	CAttrDesc(void);

};


#endif
