#include "DataObject.h"
#include "IDataSet.h"

CDataObject::~CDataObject(void){
	for(unsigned i=0;i<m_vIAttr.size();i++){
		delete m_vIAttr[i];
	}
	if(m_pIAClass) delete m_pIAClass;
}

void CDataObject::InsertAttr(IAttrValue *pIA){
	m_vIAttr.push_back(pIA);
}

void CDataObject::SetClass(IAttrValue* pIA){
	if(m_pIAClass){
		CLogger::LogError("SetClass called in wrong way",__FILE__,__LINE__);
	}
	m_pIAClass=pIA;
}

CDataObject::CDataObject(IDataSet *pIDS){
	m_pIDataSet=pIDS;
	m_pIAClass=NULL;
}

IAttrValue *CDataObject::GetClass()const{
	if(!m_pIDataSet->m_bClass || m_pIAClass==NULL){
		CLogger::LogEvent("Class attribute not found",__FILE__,__LINE__);
		return NULL;
	}
	return m_pIAClass;	
}

void CDataObject::SetClass(unsigned uIndex){
vector<IAttrValue*>::iterator atr_iter;
unsigned i;	
	
	if(uIndex >= m_vIAttr.size()) return;
	IAttrValue *pIA=m_vIAttr[uIndex];

	for (i=0,atr_iter=m_vIAttr.begin(); atr_iter != m_vIAttr.end(); atr_iter++,i++){
		if(i==uIndex){
			m_vIAttr.erase(atr_iter);
			break;
		}
	}
	
	if(m_pIAClass){
		m_vIAttr.push_back(m_pIAClass);
	}
	m_pIAClass=pIA;
}

IAttrValue* CDataObject::operator[](unsigned uIndex)const{
	//gprof if(uIndex >= m_pIDataSet->m_uCurrentAttrCount) return NULL;
	assert(uIndex < m_pIDataSet->m_uCurrentAttrCount);
	unsigned virtualIndex = m_pIDataSet->m_vMapVector[uIndex];	
	//gprof if(virtualIndex >= m_vIAttr.size()) return NULL;
	assert(virtualIndex < m_vIAttr.size());
	return m_vIAttr[virtualIndex];
}

IAttrValue* CDataObject::GetRealAttrValue(unsigned uIndex)const{
	assert(uIndex < m_pIDataSet->m_inRealAttrs);
	unsigned virtualIndex = m_pIDataSet->m_vRealAttrsMapVector[uIndex];
	return this->operator [ ](virtualIndex);
}

vector<IAttrValue*> CDataObject::GetClassValues()const{
	return m_pIDataSet->GetClassValues();
}

