#ifndef __CDATASETC45H__
#define __CDATASETC45H__

#include "IDataSet.h"

/** 
 * Zbior danych w formacie zgodnym z C4.5/C5.0
 * @author Marek Grzes'
 */
class CDataSetC45 :	public IDataSet{
private:
	/**
	 * Funkcja wczytuje metadane, czyli plik z rozszerzeniem .names formatu danych
	 * C4.5.
	 * @param fname - ciag znakow reprezentujacy nazwe pliku do wczytania
	 * @return zwraca zero kiedy funkcja konczy sie sukcesem
	 */
	int ReadMetaData(char *fname);

public:
	virtual ~CDataSetC45(void);
	
	/**
	 * @param data - nazwa pliku danych
	 * @param names - nazwa pliku z opisem danych
	 */
	virtual int ReadData(char *data, char *names);

	/**
	 * Funkcje mozna wywolac dwukrotnie, np. przy pierwszym wywolaniu wczytujac
	 * koszt klasyfikacji a przy drugim koszt testow.
	 * @param costofclassification - nazwa pliku z kosztem klasyfikacji
	 * @param costofattrs - nazwa pliku z kosztem testow
	 * @see IDataSet#CostOfClassification
	 * @see IDataSet#m_mpCostOfClassification	 
	 */
	virtual int ReadCostData(char *costofclassification, char *costofattrs);
		
	/**
	 * Konstruktor ustawiajacy nazwe zbioru danych.
	 * @see IDataSet#m_sDataSetName
	 */
	CDataSetC45(char* name);

};

#endif
