#include "NomAttr.h"
#include <vector>
#include <algorithm>

CNomAttr::CNomAttr(CAttrDesc *attrdesc){
	assert(attrdesc);
	m_pCAttrDesc = attrdesc;
}

CNomAttr::~CNomAttr(void){
}

CNomAttr::CNomAttr(const CNomAttr& templ):IAttrValue(templ.m_bMissedValue){
	assert(templ.m_pCAttrDesc);
	m_AttrValue = templ.m_AttrValue;
	m_pCAttrDesc = templ.m_pCAttrDesc;
}

CNomAttr& CNomAttr::operator=(const CNomAttr &ia){
	this->m_pCAttrDesc = ia.m_pCAttrDesc;
	this->m_bMissedValue = ia.m_bMissedValue;
	this->m_AttrValue = ia.m_AttrValue;
	return *this;
}

bool CNomAttr::operator==(const IAttrValue &ia)const{
	if(((CNomAttr&)ia).GetAttrType() == e_NominalAttr){
		if(this->m_AttrValue.u_iNom == ia.m_AttrValue.u_iNom)
			return true;
		else return false;
	}
	else{
		// ERROR:
		return false;
	}
}

bool CNomAttr::operator!=(const IAttrValue &ia)const{
	return !((*this)==ia);
}

bool CNomAttr::operator>(const IAttrValue &ia)const{
	if(((CNomAttr&)ia).GetAttrType() == e_NominalAttr){
		if(this->m_AttrValue.u_iNom > ia.m_AttrValue.u_iNom)
			return true;
		else return false;
	}
	else{
		// ERROR:
		return false;
	}
}

bool CNomAttr::operator<(const IAttrValue &ia)const{
	if(((CNomAttr&)ia).GetAttrType() == e_NominalAttr){
		if(this->m_AttrValue.u_iNom < ia.m_AttrValue.u_iNom)
			return true;
		else return false;
	}
	else{
		// ERROR:
		return false;
	}
}

AttrType CNomAttr::GetAttrType()const{
	return e_NominalAttr;
}

void CNomAttr::PrintValue(ostream &ostr)const{
	ostr<<m_AttrValue.u_iNom<<" ("<<ValueToName()<<")";
}

const char* CNomAttr::ValueToName()const{
	assert(m_pCAttrDesc);
	assert(m_pCAttrDesc->m_vAttrDomain.size()>(size_t)(m_AttrValue.u_iNom));
	return m_pCAttrDesc->m_vAttrDomain[m_AttrValue.u_iNom].c_str();
}

