#ifndef __CNOMATTRH__
#define __CNOMATTRH__

#include "AttrValue.h"
#include "DataObject.h"
#include "AttrDesc.h"

/** 
 * Klasa reprezentujaca wartosc atrybutu nominalnego. 
 * 
 * @author Marek Grzes'
 */
class CNomAttr : public IAttrValue
{
public:
	virtual AttrType GetAttrType()const;
	virtual CNomAttr& operator=(const CNomAttr &ia);
	virtual bool operator==(const IAttrValue &ia)const;
	virtual bool operator!=(const IAttrValue &ia)const;
	virtual bool operator>(const IAttrValue &ia)const;
	virtual bool operator<(const IAttrValue &ia)const;	
	virtual void PrintValue(ostream &ostr)const;

	/** Metoda zwraca nazwe wartosci nominalnej, ktorej odpowiada biezacy obiekt
	 * klasy CNomAttr.
	 */
	virtual const char* ValueToName()const;

	CNomAttr(CAttrDesc *attrdesc);
	CNomAttr(const CNomAttr& templ);
	virtual ~CNomAttr(void);

protected:
	/** Wskaznik do metadanych.
	 */
	CAttrDesc *m_pCAttrDesc;
};


#endif
