#include "TempDataSet.h"
#include "../MLPCommon/Logger.h"

CTempDataSet::CTempDataSet(char* name):IDataSet(name){
	m_bTempDataSet = true;
}

CTempDataSet::CTempDataSet(const IDataSet &templ):IDataSet((char*)(templ.m_sDataSetName.c_str())){
	this->m_bTempDataSet = true;
	this->m_bClass = templ.m_bClass;
	this->m_pCAttrDescClass = templ.m_pCAttrDescClass;
	this->m_uAttrCount = templ.m_uAttrCount;
	this->m_uCurrentAttrCount = templ.m_uCurrentAttrCount;
	this->m_vAttrDesc = templ.m_vAttrDesc;
	this->m_vMapVector = templ.m_vMapVector;
	this->m_vRealAttrsMapVector = templ.m_vRealAttrsMapVector;
	this->m_inRealAttrs = templ.m_inRealAttrs;
	this->m_bCostOfClassification = templ.m_bCostOfClassification;
	this->m_bCostOfAttrs = templ.m_bCostOfAttrs;
	this->m_mpCostOfClassification = templ.m_mpCostOfClassification;
	// this->m_dCDataObject nie jest ustawiany. Musi byc dodany w SplitDataSet().
}


CTempDataSet::~CTempDataSet(void){
}

int CTempDataSet::ReadCostData(char *str1, char *str2){
	CLogger::LogEvent("This method musn't be called",__FILE__,__LINE__);
	return 1;
}

int CTempDataSet::ReadData(char *str1, char *str2){
	CLogger::LogEvent("This method musn't be called",__FILE__,__LINE__);
	return 1;
}

IDataSet& CTempDataSet::operator+=(const IDataSet &ids){
	if(this->m_sDataSetName != ids.m_sDataSetName){
		CLogger::LogError("Different datasets",__FILE__,__LINE__);
		return *this;
	}
	for(size_t t=0; t<ids.m_dCDataObject.size(); t++){
		this->m_dCDataObject.push_back(ids.m_dCDataObject[t]);
	}
	return *this;
}

// DORDU BEGIN
CTempDataSet::CTempDataSet(const IDataSet &templ, const vector<int> &vClassIndexes)
						  : IDataSet((char*)(templ.m_sDataSetName.c_str()))
{
	this->m_bTempDataSet = true;
	this->m_bClass = templ.m_bClass;
	this->m_pCAttrDescClass = templ.m_pCAttrDescClass;
	this->m_uAttrCount = templ.m_uAttrCount;
	this->m_uCurrentAttrCount = templ.m_uCurrentAttrCount;
	this->m_vAttrDesc = templ.m_vAttrDesc;
	this->m_vMapVector = templ.m_vMapVector;

	this->m_bCostOfClassification = templ.m_bCostOfClassification;
	this->m_bCostOfAttrs = templ.m_bCostOfAttrs;
	this->m_mpCostOfClassification = templ.m_mpCostOfClassification;


	size_t iClassCount=vClassIndexes.size();
	
	int iDataSetClassCount=templ.GetCurrentClassCount();
	for (size_t i=0; i<iClassCount; i++){
		if( !( (vClassIndexes[i]>-1) && (vClassIndexes[i]<iDataSetClassCount) ) ){
			CLogger::LogError("iDataSetClassCount",__FILE__,__LINE__);
		}
	}

	
	size_t iObsCount = templ.GetSize();
	for (size_t t=0; t<iObsCount; t++)
	{
		//const CDataObject *p = (*templ)[t]; //??
		const CDataObject *p = templ[t];

		IAttrValue *c = p->GetClass();
		int iClassIndex=c->m_AttrValue.u_iNom;
		
		if ( IsInIndexes(vClassIndexes, iClassIndex) )
			this->m_dCDataObject.push_back(templ.m_dCDataObject[t]);
			
	}
}

// DORDU END
