#include <iostream>
#include <vector>
#include <cstdlib>
#include <ctime>

#include "../MLPClassification/ConstInducer.h"
#include "../MLPClassification/TestClassificationExperiment.h"
#include "../MLPDT_TD/TDIDTInducer.h"
#include "../MLPDT_TD/TDIDTRandInducer.h"
#include "../MLPClassification/CVClassificationExperiment.h"
#include "../MLPDataset/DataSetC45.h"

using namespace std;

int main(int argc, char *argv[])
{
	/* Inicjalizacja generatora liczb pseudolosowych.
	 */
	srand( (unsigned)time( NULL ) );
	for(int i=0, n=10*rand()/RAND_MAX; i<n; i++) rand();

	IDataSet *idataset = new CDataSetC45("dataset1");
	
	if(argc==3){
		idataset->ReadData(argv[1],argv[2]);
	}
	else{ 
		//idataset->ReadData("d:/mlp/dane/tutorial.all","d:/mlp/dane/tutorial.names");
		idataset->ReadData("d:/mlp/dane/iris.all","d:/mlp/dane/iris.names");
	}
	cout << endl;

	//---------------------------------------------------

	IInducer *itInducer = new CTDIDTInducer();

	//itInducer->SetParam("minimum items","3");
	itInducer->SetParam("pruning","yes");
	//itInducer->SetParam("number of iterations","100");
	itInducer->SetParam("selection of a test","gain ratio criterion");
	//itInducer->SetParam("selection of a test","random");

	CCVClassificationExperiment cv(&cout);
	cv.SetDataSetsCount(5);

	vector<IInducer*> v(2);
	v[0] = itInducer;
	v[1] = itInducer;
//-	cv.RunTest(idataset,v);
//-	cv.RunTest(idataset,itInducer);

	deque<const IDataSet*> deqds(2);
	deqds[0] = idataset;
	deqds[1] = idataset;
	vector<const IDataSet*> m;
//-	cv.RunTest(deqds,v,m);

	//---------------------------------------------------
	
	cout << "\nThe End\n";
	delete itInducer;
	delete idataset;
	return (0);
}
