#include <iostream>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include <string>
#include <sstream>

#include "../MLPDataset/DataSetC45.h"

using namespace std;

int main(int argc, char *argv[])
{
	/* Inicjalizacja generatora liczb pseudolosowych.
	 */
	srand( (unsigned)time( NULL ) );
	for(int i=0, n=10*rand()/RAND_MAX; i<n; i++) rand();

	IDataSet *idataset = new CDataSetC45("dataset1");
	IDataSet *itestdataset = new CDataSetC45("testdataset1");
	
	if(argc==4){
		idataset->ReadData(argv[1],argv[2]);
		itestdataset->ReadData(argv[3],argv[2]);
	}
	else{ 
		idataset->ReadData("d:/mlp/dane/tutorial.data","d:/mlp/dane/tutorial.names");
		itestdataset->ReadData("d:/mlp/dane/tutorial.test","d:/mlp/dane/tutorial.names");
		//idataset->ReadData("d:/mlp/dane1/breast-cancer-wisconsin.data","d:/mlp/dane1/breast-cancer-wisconsin.names");
		//itestdataset->ReadData("d:/mlp/dane1/breast-cancer-wisconsin.test","d:/mlp/dane1/breast-cancer-wisconsin.names");
		//idataset->ReadData("d:/mlp/dane1/irisall.data","d:/mlp/dane1/irisall.names");
		//itestdataset->ReadData("d:/mlp/dane1/irisall.data","d:/mlp/dane1/irisall.names");
	}
	cout << endl;
	idataset->PrintDSInHumanReadableFormat(&cout);
	itestdataset->PrintDSInHumanReadableFormat(&cout);

	/*vector<unsigned> torem;
	torem.clear();
	torem.insert(torem.end(),1);
	torem.insert(torem.end(),2);
	idataset->RemoveAttr(torem);
	idataset->PrintDSInHumanReadableFormat(&cout);
	
	torem.clear();
	torem.insert(torem.end(),0);
	idataset->RemoveAttr(torem);
	idataset->PrintDSInHumanReadableFormat(&cout);
	
	torem.clear();
	torem.insert(torem.end(),2);
	idataset->RemoveAttr(torem);
	idataset->PrintDSInHumanReadableFormat(&cout);*/

	// ------------------------------------------------------------------
	vector<unsigned> torem;
	torem.insert(torem.end(),0);
	idataset->RemoveAttr(torem);

	deque<const IDataSet*> ds = idataset->SplitDataSet(10);
	int m = 0;
	string meta="dataset.names";
	while(!ds.empty()){
		ofstream outfile;
		stringstream s;
		s<<"dataset_"<<m<<".data";
		outfile.open(s.str().c_str(),ofstream::out);
		// ________________________________________________________________	
		const IDataSet *ci = ds.front();
		vector<IAttrValue*> v = ci->GetClassValues();
		vector<int> c(v.size(),0);
		for(unsigned t=0; t<ci->GetSize(); t++){
			for(unsigned k=0; k<v.size(); k++){
				CDataObject* cinst = (*ci)[t];
				if( *v[k] == *(cinst->GetClass()) ){
					c[k]++;
					break;
				}
			}
		}
		cout<<"Split: "<<m<<" \t\tsize="<<ci->GetSize()<<endl;
		for(size_t t=0; t<c.size(); t++){
			v[t]->PrintValue(cout);
			cout<<" "<<c[t]<<endl;
		}
		// ________________________________________________________________	
		if(m==0){
			ofstream outnames;
			outnames.open(meta.c_str(),ofstream::out);
            ds.front()->PrintDSInC45Format(&outfile,&outnames);
			outnames.close();
		}else{
            ds.front()->PrintDSInC45Format(&outfile);
		}
		outfile.close();
		delete ds.front();
		ds.pop_front();
		m++;
	}
	// ------------------------------------------------------------------

	cout << "\nThe End\n";

	delete idataset;
	delete itestdataset;
	return (0);
}
