#include "ClassifierDescription.h"

CClassifierDescription::CClassifierDescription(void){
	m_pInducer	= 0;
	m_bParam1	= false;
	m_bParam2	= false;
}

CClassifierDescription::~CClassifierDescription(void){
	if(m_pInducer) delete m_pInducer;
}

IInducer* CClassifierDescription::GetFirstInducer(string &logval, string &pnames){
	if(!m_bParam1 && !m_bParam2){
		logval = "";
		pnames = "";
		return m_pInducer;
	}
	if(m_bParam1 && !m_bParam2){
		m_iParamIndex1 = 0;
		// Poprawnosc parametrow byla sprawdzana przy wczytywaniu z pliku
		m_pInducer->SetParam(m_sParamName1,m_vsParamList1[m_iParamIndex1]);
		logval = m_vsParamList1[m_iParamIndex1];
		pnames = m_sParamName1;
		return m_pInducer;
	}
	if(m_bParam1 && m_bParam2){
		m_iParamIndex1 = 0;
		m_iParamIndex2 = 0;
		m_pInducer->SetParam(m_sParamName1,m_vsParamList1[m_iParamIndex1]);
		m_pInducer->SetParam(m_sParamName2,m_vsParamList2[m_iParamIndex2]);
		logval =  m_vsParamList1[m_iParamIndex1];
		logval += "_"+m_vsParamList2[m_iParamIndex2];
		pnames = m_sParamName1+"_"+m_sParamName2;
		return m_pInducer;
	}
	return 0;
}
	
IInducer* CClassifierDescription::GetNextInducer(string &logval, string &pnames){
	if(!m_bParam1 && !m_bParam2){
		logval="";
		pnames = "";
		return 0;
	}
	if(m_bParam1 && !m_bParam2){
		m_iParamIndex1++;
		if(m_iParamIndex1<(int)m_vsParamList1.size()){
			m_pInducer->SetParam(m_sParamName1,m_vsParamList1[m_iParamIndex1]);
			logval = m_vsParamList1[m_iParamIndex1];
			pnames = m_sParamName1;
			return m_pInducer;
		}else{
			return 0;
		}
	}
	if(m_bParam1 && m_bParam2){
		m_iParamIndex2++;
		if(m_iParamIndex2 >= (int)m_vsParamList2.size()){
			m_iParamIndex2 = 0;
			m_iParamIndex1++;
			if(m_iParamIndex1 >= (int)m_vsParamList1.size()){
				return 0;
			}
		}
		m_pInducer->SetParam(m_sParamName1,m_vsParamList1[m_iParamIndex1]);
		m_pInducer->SetParam(m_sParamName2,m_vsParamList2[m_iParamIndex2]);
		logval =  m_vsParamList1[m_iParamIndex1];
		logval += "_"+m_vsParamList2[m_iParamIndex2];
		pnames = m_sParamName1+"_"+m_sParamName2;
		return m_pInducer;
	}
	return 0;
}
