#include "ICF.h"

long double CICF::EG2(deque<CDataObject*> &deqCI, ITest *pIT, vector<int> vDepth, const IDataSet *pDataSet){
	long double dinfo=CEntropy::Gain(deqCI,pIT);
	
	if (omega>1.0 || omega<0.0){
		omega=1.0;
	}

	if (vDepth[pIT->GetAttrNum()]!=-1){
		return (pow((long double)2,dinfo)-1);
	}
	else{
		double dcost = pDataSet->GetCostOfAttribute(pIT->GetAttrNum());
		//double dcost = pDataSet->m_vAttrDesc[]->m_fCost;
		return ((pow((long double)2,dinfo)-1)/pow((dcost+1),omega));	
		
	}
}

long double CICF::CSID3(deque<CDataObject*> &deqCI, ITest *pIT, vector<int> vDepth, const IDataSet *pDataSet){

	long double dinfo=CEntropy::Gain(deqCI,pIT);

	if (vDepth[pIT->GetAttrNum()]!=-1){
		return dinfo*dinfo;
	}
	else{
		double dcost = pDataSet->GetCostOfAttribute(pIT->GetAttrNum());
		//double dcost = pDataSet->m_vAttrDesc[pIT->m_iAttrNum]->m_fCost;
		return (dinfo*dinfo/(dcost+1));	
	}
	
}

long double CICF::IDX(deque<CDataObject*> &deqCI, ITest *pIT, vector<int> vDepth, const IDataSet *pDataSet){
	long double dinfo=CEntropy::Gain(deqCI,pIT);

	if (vDepth[pIT->GetAttrNum()]!=-1){
		return dinfo;
	}
	else{
		double dcost = pDataSet->GetCostOfAttribute(pIT->GetAttrNum());
		//double dcost = pDataSet->m_vAttrDesc[pIT->m_iAttrNum]->m_fCost;
		return (dinfo/(dcost+1));
	}
	
}

long double CICF::PCost(deque<CDataObject*> &deqCI, ITest *pIT, vector<int> vDepth, const IDataSet *pDataSet){
long double P;
long double Et;

P = deqCI.size();

	if(P == 0){
		return 0;
	}

	vector<vector<unsigned> > vvDiv = pIT->GetSubSets(deqCI);

	
	Et = 0;
	for(unsigned i=0; i<vvDiv.size(); i++){
		deque<CDataObject*> subset;
		vector<unsigned> subIDs = vvDiv[i];
		for(unsigned j=0; j<subIDs.size(); j++){
			subset.push_back(deqCI[subIDs[j]]);
		}
		/* Obliczenie entropii dla i-tego przedzialu wyznaczonego przez
		 * i-ty wynik testu.
		 */
		long double Etr = Purity(subset);

		Et += (long double) subset.size() / P * Etr;
	}

	if (vDepth[pIT->GetAttrNum()]!=-1){
		return (Et/(long double)vvDiv.size());
	}
	else{
		double dcost = pDataSet->GetCostOfAttribute(pIT->GetAttrNum());
		//double dcost = pDataSet->m_vAttrDesc[pIT->m_iAttrNum]->m_fCost;
		return ((Et/(long double)vvDiv.size())/(dcost+1));
	}
}

long double CICF::Purity(deque<CDataObject*> &deqCI){
map<IAttrValue*,unsigned> mapIAu;
map<IAttrValue*,unsigned>::iterator iter;
long double P;
long double ldPurity;

	P = deqCI.size();

	if(P == 0){
		return 0;
	}

	for(unsigned i=0; i < deqCI.size(); i++){
		int n=0;
		IAttrValue *pIA = deqCI[i]->GetClass();

		for(iter=mapIAu.begin(); iter!=mapIAu.end(); iter++){
			if( *(iter->first) == *pIA ){
				iter->second++;
				n=1;
				break;
			}
		}
		if(n==0){
			pair<IAttrValue*,unsigned> p;
			p.first = pIA;
			p.second = 1;
			mapIAu.insert(p);
		}
	}
	
	ldPurity = 0;

	for(iter=mapIAu.begin(); iter!=mapIAu.end(); iter++){
		long double wsp = (long double)iter->second/P;
		if(wsp != 0)
			ldPurity += wsp * wsp;
	}
	return ldPurity;
}

double CICF::omega=0.5;
