#ifndef __EAIDTINDIVIDUALH__
#define __EAIDTINDIVIDUALH__

#include "../../mlpcore/MLPCommon/IIndividual.h"
#include "../../mlpcore/MLPDT/DTreeNode.h"

#define EAIND(A) ((CEAIDTIndividual*)(A))

/**
 * Osobnik przy generowaniu drzewa decyzyjnego z wykorzystaniem algorytmu
 * ewolucyjnego.
 *
 * @author Marek Grzes'
 */ 
class CEAIDTIndividual: public IIndividual{
public:
	CDTreeNode *m_CDTIndRoot;

	/**
	 * Zwraca rozmiar drzewa (m_CDTIndRoot) dla algorytmu indukcji drzew mieszanych.
	 */
	double GetNodeCount_APOB(double pr);
	double GetNodeCount_APOB(double pr, CDTreeNode* node);

	/**
	 * Zwraca rozmiar drzewa (m_CDTIndRoot) z uwzglednieniem selekcji cech.
	 */
	double GetNodeCount_FS(double beta);
	double GetNodeCount_FS(double beta, CDTreeNode* node);

	virtual IIndividual* Clone() const;
	
	CEAIDTIndividual(void);
	CEAIDTIndividual(const CEAIDTIndividual &templ);
	virtual ~CEAIDTIndividual(void);
};

#endif

