#ifndef __CMTTESTH__
#define __CMTTESTH__

#include "../../mlpcore/MLPDT/ITest.h"

/**
 * Interfejs testu.
 * @author Marek Grzes
 */
class CMTTest: public ITest{
friend class CTDIDTMTNAPInducer;

public:
	/**
	 * Przyjmujemy zalozenie ze wszystkie testy w danym CMTTest maja taka sama liczbe wyjsc.
	 */
	virtual unsigned GetSubSetCount()const;

	virtual vector<vector<unsigned> > GetSubSets(deque<CDataObject*> deqCI)const;

	/**
	 * Operator do porownywania testow.
	 */
	virtual bool operator==(const ITest& it)const;

	virtual bool operator<(const ITest& it)const{
		return false;
	}
	virtual bool operator>(const ITest& it)const{
		return false;
	}

	/**
	 * Zwraca koszt atrybutw uzytych w danym tescie.
	 */
	virtual float GetCostOfAttributes(const IDataSet* dataset)const;
	
	/**
	 * Zwraca koszt atrybutow uzytych w danym tescie, dla ktorych
	 * vUsed[attrNum]==false. Jesli jakis atrybut zostaje tu zliczony to
	 * vUsed[attrNum]=true.
	 */
	virtual float GetCostOfAttributes(const IDataSet* dataset, vector<bool> &vUsed)const;


	virtual unsigned GetBranchID(CDataObject *pCInst)const;
	virtual void PrintTest(unsigned branchid, const IDataSet* dataset, ostream &ostr)const;
	virtual ITest* CloneTest()const;

	/**
	 * Przekazane w parametrze wskazniki do testow beda zapamietane. Dlatego trzeba
	 * robic kopie przed wywolaniem konstruktora.
	 */
	CMTTest(vector<ITest*> tests);
	virtual ~CMTTest(void);

protected:
	// Testy, ktore agreguje biezacy wezel zlozony
	vector<ITest*> m_vTests;
};

#endif

