#ifndef __CTDIDTMNTAPINDUCER__
#define __CTDIDTMNTAPINDUCER__

#include "../../mlpcore/MLPDT_TD/TDIDTInducer.h"
#include "MTTest.h"

/**
 * @author Marek Grzes <marekg@ii.pb.bialystok.pl>, (C) 2006
 */
class CTDIDTMTNAPInducer : public CTDIDTInducer{
public:

	virtual string GetName();
	virtual vector<string> GetParams() const;
	virtual void PrintParamsXML(ostream &ostr, int nsp);
	virtual bool SetParam(string sParamName, string sParamValue);

	CTDIDTMTNAPInducer(void);
	virtual ~CTDIDTMTNAPInducer(void);

	virtual ITest* PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);

protected:
	/**
	 * Liczba testow do wykorzystania w tescie wielotestowym.
	 */
	unsigned m_uNTests;

private:
	ITest* BuildMultiTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);

	/**
	 * Po zbudowaniu testu z wieloma testmi moze sie tak zdazyc ze glosowanie bedzie powodowalo to ze test nie bedzie
	 * nic obcinal. Dlatego trzeba to sprawdzic. Jesli test nic nie separuje to wowczas wyrzucamy po dwa test z wektora
	 * testow (wyrzucanie od konca).
	 */
	ITest* CheckMultiTest(CMTTest* test, deque<CDataObject*> &deqCI, const IDataSet *trainingDataSet);
};

#endif
