#include "TDIDTCSInducer.h"
#include "../MLPDT/ICF.h"

#include "../../mlpcore/MLPDataset/NomAttr.h"
#include "../../mlpcore/MLPDataset/RealAttr.h"

#include <typeinfo>

CTDIDTCSInducer::CTDIDTCSInducer(){
}

CTDIDTCSInducer::~CTDIDTCSInducer(void){
}

ITest* CTDIDTCSInducer::PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet){
	if((m_sSelectionOfATest=="eg2") ||
		(m_sSelectionOfATest=="idx") ||
		(m_sSelectionOfATest=="csid3") ||
		(m_sSelectionOfATest=="pcost")){
		return PickOutICF(deqCI,tests,trainingDataSet);
	}
	
	if(m_sSelectionOfATest=="mincost"){
		return PickOutMinCost(deqCI,tests,trainingDataSet);
	}
	return CTDIDTInducer::PickOutTest(deqCI,tests,trainingDataSet);
}

ITest* CTDIDTCSInducer::PickOutICF(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet){
	unsigned maxindex=0;
	long double maxgain;
	long double temp=0.0;
	//pobranie kosztu bdnej klasyfikacji zbioru
	double dMisCost=GetMissclasificationCost(deqCI,trainingDataSet);

	if (m_bCostOfClassification){
		if(DoDivision(deqCI,tests[0], temp)){
			if(m_sSelectionOfATest=="eg2"){
				maxgain = CICF::EG2(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="csid3"){
				maxgain = CICF::CSID3(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="idx"){
				maxgain = CICF::IDX(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="pcost"){
				maxgain = CICF::PCost(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
			}
			if ((m_vAttrBranch[tests[0]->GetAttrNum()]!=-1) || (!m_bCostOfAttrs)){
				if (temp>dMisCost){
					maxgain=0.0;
				}
			}else{
				if ((deqCI.size()*trainingDataSet->GetCostOfAttribute((tests[0])->GetAttrNum())+temp)>dMisCost){
					maxgain=0.0;
				}					
			}
		}
		else{
			maxgain=0.0;
		}
	}
	else{
		if(m_sSelectionOfATest=="eg2"){
			maxgain = CICF::EG2(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
		}
		if(m_sSelectionOfATest=="csid3"){
				maxgain = CICF::CSID3(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
		}
		if(m_sSelectionOfATest=="idx"){
			maxgain = CICF::IDX(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
		}
		if(m_sSelectionOfATest=="pcost"){
			maxgain = CICF::PCost(deqCI,tests[0],m_vAttrBranch,trainingDataSet);
		}
	}
	
	for(unsigned i=1 ; i<tests.size(); i++){
		long double gain;
		temp=0.0;
		if (m_bCostOfClassification){
			if(DoDivision(deqCI,tests[i],temp)){
				if(m_sSelectionOfATest=="eg2"){
					gain = CICF::EG2(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
				}
				if(m_sSelectionOfATest=="csid3"){
					gain = CICF::CSID3(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
				}
				if(m_sSelectionOfATest=="idx"){
					gain = CICF::IDX(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
				}
				if(m_sSelectionOfATest=="pcost"){
					gain = CICF::PCost(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
				}
				//czy koszt zastosowania testu nie przekroczy kosztu bdnej klasyfikacji
				if (m_bCostOfClassification){
					if (m_vAttrBranch[tests[i]->GetAttrNum()]!=-1){
						if (temp>dMisCost){
							gain=0.0;
						}
					}
					else{
						if ((deqCI.size()*trainingDataSet->GetCostOfAttribute((tests[i])->GetAttrNum())+temp)>dMisCost){
							gain=0.0;
						}
					}
				}			
			}
			else{
				gain=0.0;
			}
		}
		else{
			if(m_sSelectionOfATest=="eg2"){
				gain = CICF::EG2(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="csid3"){
					gain = CICF::CSID3(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="idx"){
				gain = CICF::IDX(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
			}
			if(m_sSelectionOfATest=="pcost"){
				gain = CICF::PCost(deqCI,tests[i],m_vAttrBranch,trainingDataSet);
			}
		}
		if(gain > maxgain){
			maxgain = gain;
			maxindex = i;
		}
	}

	if(fabs(maxgain)<10e-10) return NULL;
	ITest* res = tests[maxindex]->CloneTest();
	
	//zwiekszenie kosztu
	if (m_vAttrBranch[res->GetAttrNum()]==-1){
		m_vAttrBranch[res->GetAttrNum()]=m_iCurrentDepth;
		//pDS->m_vAttrDesc[res->m_iAttrNum]->m_isUsed=true;
	}
		
	return res;
}


ITest* CTDIDTCSInducer::PickOutMinCost(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet){
	unsigned maxindex=0;
	long double maxgain;
	long double temp=0.0;
	//pobranie kosztu bdnej klasyfikacji zbioru
	double dMisCost=GetMissclasificationCost(deqCI,trainingDataSet);

	bool a=!m_bCostOfClassification;
	if (a || (!m_bCostOfAttrs)){
		return NULL;
	}
	
	if(DoDivision(deqCI,tests[0], temp)){
		if (m_vAttrBranch[tests[0]->GetAttrNum()]!=-1){
			maxgain=dMisCost-temp;
		}else{
			maxgain=dMisCost-temp-(deqCI.size()*trainingDataSet->GetCostOfAttribute((tests[0])->GetAttrNum()));
		}
	}
	else {
		maxgain=-1;
	}
	
	for(unsigned i=1 ; i<tests.size(); i++){
		long double gain;
		temp=0.0;
		if(DoDivision(deqCI,tests[i], temp)){
			if (m_vAttrBranch[tests[i]->GetAttrNum()]!=-1){
				gain=dMisCost-temp;
			}else{
				gain=dMisCost-temp-(deqCI.size()*trainingDataSet->GetCostOfAttribute((tests[i])->GetAttrNum()));
			}
		}
		else {
			gain=-1;
		}

		if(gain > maxgain){
			maxgain = gain;
			maxindex = i;
		}
	}

	if(maxgain<0) 
		return NULL;
	ITest* res = tests[maxindex]->CloneTest();
	
	//zwiekszenie kosztu
	if (m_vAttrBranch[res->GetAttrNum()]==-1){
		m_vAttrBranch[res->GetAttrNum()]=m_iCurrentDepth;
		//pDS->m_vAttrDesc[res->m_iAttrNum]->m_isUsed=true;
	}
		
	return res;
}

bool CTDIDTCSInducer::SetParam(string sParamName, string sParamValue){
	string::iterator i = sParamName.begin();
	while(i != sParamName.end()){
		*i = tolower(*i);
		++i;
	}
	i = sParamValue.begin();
	while(i != sParamValue.end()){
		*i = tolower(*i);
		++i;
	}

	if(sParamName=="selection of a test" || sParamName=="selectionofatest"){
		if((sParamValue=="eg2") ||
		(sParamValue=="idx") ||
		(sParamValue=="csid3") ||
		(sParamValue=="mincost") ||
		(sParamValue=="pcost")){
			m_sSelectionOfATest=sParamValue;
			return true;
		}
	}
	return CTDIDTInducer::SetParam(sParamName,sParamValue);
}

void CTDIDTCSInducer::PreBuildTree(ITestContainer &tests, const IDataSet *trainingDataSet){
	m_vAttrBranch.clear();
	for(unsigned i=0;i<trainingDataSet->GetCurrentAttrCount();i++){
		m_vAttrBranch.push_back(-1);
	}
	CTDIDTInducer::PreBuildTree(tests,trainingDataSet);
}


IAttrValue* CTDIDTCSInducer::Category(deque<CDataObject*> &deqCI, IAttrValue *pIA, double &dCost){

	dCost=0.0;
	vector<sCounter*> vs;
	if (deqCI.size()==0)
		return pIA;
	if(m_bCostOfClassification){
		if(deqCI.size()>0){
			// Wektor par (klasa, koszt)
			vector<pair<IAttrValue*, double> > classCost;
			// Wyszukanie wszystkich klas
			for(unsigned int i=0;i<deqCI.size();i++){
				CDataObject *inst = deqCI[i];
				int x=0;
				for(unsigned int j=0;j<classCost.size();j++){
					IAttrValue *ia1=classCost[j].first;
					IAttrValue *ia2=inst->GetClass();
					if((*ia1)==(*ia2)){
						x=1;
						break;
					}
				}
				if(x==0){
					pair<IAttrValue*, double> p(inst->GetClass(),0);
					classCost.push_back(p);
				}
			}
			// Sprawdzenie jaki jest koszt klasyfikacji przy wyborze kazdej z klas
			// od razu znalezenie najlepszej klasy (czyli mininalny koszt)
			int minIndex = -1;
			double minCost = -1;
			for(size_t clID=0; clID<classCost.size(); clID++){
				IAttrValue *ia1=classCost[clID].first;
				for(unsigned int i=0;i<deqCI.size();i++){
					IAttrValue *ia2=deqCI[i]->GetClass();
					try{
						CNomAttr& predC = dynamic_cast<CNomAttr&>(*ia1);
						CNomAttr& trueC = dynamic_cast<CNomAttr&>(*ia2);
						classCost[clID].second += m_pDataset->CostOfClassification(predC,trueC);
					}
					catch(bad_cast){
					}
					// Jezeli juz mamy wiekszy koszt niz min to nie ma co isc dalej
					// przerywamy
					if(minIndex != -1 && classCost[clID].second > minCost){
						break;
					}
				}
				if(minIndex == -1){
					minIndex = clID;
					minCost = classCost[clID].second;
				}else{
					if(classCost[clID].second < minCost){
						minIndex = clID;
						minCost = classCost[clID].second;
					}
				}
			}
			dCost=classCost[minIndex].second;
			return classCost[minIndex].first;
		}else{
			return pIA;
		}
	}else{
		if(deqCI.size()>0){
			for(unsigned int i=0;i<deqCI.size();i++){
				CDataObject *inst = deqCI[i];
				int x=0;
				for(unsigned int j=0;j<vs.size();j++){
					IAttrValue *ia1=vs[j]->s_pIAttrValue;
					IAttrValue *ia2=inst->GetClass();
					if((*ia1)==(*ia2)){
						vs[j]->s_Counter++;
						x=1;
						break;
					}
				}
				if(x==0){
					sCounter *t=new sCounter;
					t->s_Counter=1;
					t->s_pIAttrValue=inst->GetClass();
					vs.insert(vs.end(),t);
				}
			}
		
			int max = 0;
			IAttrValue* pmaxClass=NULL;
			for(unsigned int i=0;i<vs.size();i++){
				if(vs[i]->s_Counter>max){
					max = vs[i]->s_Counter;
					pmaxClass = vs[i]->s_pIAttrValue;
				}
			}
			for(unsigned int i=0; i<vs.size();i++){
				delete vs[i];
			}
			return pmaxClass;
		}else{
			return pIA;
		}
	}
}

//-CS-
IAttrValue* CTDIDTCSInducer::Category(const IDataSet* dataset, deque<CDataObject*> &deqCI, IAttrValue *pIA){
vector<sCounter*> vs;
	if(m_bCostOfClassification){
		if(deqCI.size()>0){
			// Wektor par (klasa, koszt)
			vector<pair<IAttrValue*, double> > classCost;
			// Wyszukanie wszystkich klas
			for(unsigned int i=0;i<deqCI.size();i++){
				CDataObject *inst = deqCI[i];
				int x=0;
				for(unsigned int j=0;j<classCost.size();j++){
					IAttrValue *ia1=classCost[j].first;
					IAttrValue *ia2=inst->GetClass();
					//MC
					if (ia1==NULL || ia2==NULL){
						return pIA;
					}
					//MC
					if((*ia1)==(*ia2)){
						x=1;
						break;
					}
				}
				if(x==0){
					pair<IAttrValue*, double> p(inst->GetClass(),0);
					classCost.push_back(p);
				}
			}
			// Sprawdzenie jaki jest koszt klasyfikacji przy wyborze kazdej z klas
			// od razu znalezenie najlepszej klasy (czyli mininalny koszt)
			int minIndex = -1;
			double minCost = -1;
			for(size_t clID=0; clID<classCost.size(); clID++){
				IAttrValue *ia1=classCost[clID].first;
				for(unsigned int i=0;i<deqCI.size();i++){
					IAttrValue *ia2=deqCI[i]->GetClass();
					try{
						CNomAttr& predC = dynamic_cast<CNomAttr&>(*ia1);
						CNomAttr& trueC = dynamic_cast<CNomAttr&>(*ia2);
						classCost[clID].second += dataset->CostOfClassification(predC,trueC);
					}
					catch(bad_cast){
					}
					// Jezeli juz mamy wiekszy koszt niz min to nie ma co isc dalej
					// przerywamy
					if(minIndex != -1 && classCost[clID].second > minCost){
						break;
					}
				}
				if(minIndex == -1){
					minIndex = clID;
					minCost = classCost[clID].second;
				}else{
					if(classCost[clID].second < minCost){
						minIndex = clID;
						minCost = classCost[clID].second;
					}
				}
			}
			return classCost[minIndex].first;
		}else{
			return pIA;
		}
	}else{
		if(deqCI.size()>0){
			for(unsigned int i=0;i<deqCI.size();i++){
				CDataObject *inst = deqCI[i];
				int x=0;
				for(unsigned int j=0;j<vs.size();j++){
					IAttrValue *ia1=vs[j]->s_pIAttrValue;
					IAttrValue *ia2=inst->GetClass();
					if((*ia1)==(*ia2)){
						vs[j]->s_Counter++;
						x=1;
						break;
					}
				}
				if(x==0){
					sCounter *t=new sCounter;
					t->s_Counter=1;
					t->s_pIAttrValue=inst->GetClass();
					vs.insert(vs.end(),t);
				}
			}
		
			int max = 0;
			IAttrValue* pmaxClass=NULL;
			for(unsigned int i=0;i<vs.size();i++){
				if(vs[i]->s_Counter>max){
					max = vs[i]->s_Counter;
					pmaxClass = vs[i]->s_pIAttrValue;
				}
			}
			for(unsigned int i=0; i<vs.size();i++){
				delete vs[i];
			}
			return pmaxClass;
		}else{
			return pIA;
		}
	}
}
//-CS-

//-CS-
CDTreeNode* CTDIDTCSInducer::BuildTree(deque<CDataObject*> &deqCI, ITestContainer &tests, IAttrValue *pIA, const IDataSet *trainingDataSet){
// CTDIDTInducerAPDepthK
	m_iCurrentDepth++;
// CTDIDTInducerAPDepthK
	CDTreeNode * pnode = new CDTreeNode();
	IAttrValue* temp = Category(trainingDataSet,deqCI,pIA);
	//MC
	if (temp==NULL)
		return NULL;
	//MC
	if(temp->GetAttrType() == e_NominalAttr){
		pnode->m_pIAClass = new CNomAttr((CNomAttr&)*temp);
	}
	if(temp->GetAttrType() == e_RealAttr){
		pnode->m_pIAClass = new CRealAttr((CRealAttr&)*temp);
	}
	pnode->m_deqCI = deqCI;

	if(StopCondition(deqCI,tests.size())){
		pnode->m_bLeaf = true;
// CTDIDTInducerAPDepthK
		m_iCurrentDepth--;
// CTDIDTInducerAPDepthK
		return pnode;
	}else{

		//MC
		//jezeli uzywany jest koszt testow
		if (m_bCostOfAttrs){
			for(unsigned i=0;i<m_vAttrBranch.size();i++){
				if (m_vAttrBranch[i]>=m_iCurrentDepth){
					m_vAttrBranch[i]=-1;
				}
			}
		}
		//MC
		// Wybierz test, zwrocony test jest usuwany z vITraintest.
		ITest* test = PickOutTest(deqCI,tests,trainingDataSet);
		// NULL bedzie zwrocony jak juz zadan test nie daje przyrostu
		// informacji, czyli warunek stopu i utworzenie liscia.
		if(test == NULL){
			pnode->m_bLeaf = true;
// CTDIDTInducerAPDepthK
			m_iCurrentDepth--;
// CTDIDTInducerAPDepthK
			return pnode;
		}

		// Utworz tablice podzialow
		vector<vector<unsigned> > vvDiv = test->GetSubSets(deqCI);

		//- cerr<<"Podzialow="<<vvDiv.size()<<endl;
		// Dla kazego podzbioru wynikajacego z podzialu: BuildTree
		for(unsigned i=0; i<vvDiv.size(); i++){
			deque<CDataObject*> subset;
			vector<unsigned> subIDs = vvDiv[i];
			for(unsigned j=0; j<subIDs.size(); j++){
				subset.insert(subset.end(),deqCI[subIDs[j]]);
			}
			//-cerr<<"Node="<<deqCI.size()<<"  Part="<<subset.size()<<" depht="<<m_iCurrentDepth<<endl;
			CDTreeNode* node = BuildTree(subset,tests,pnode->m_pIAClass, trainingDataSet);
			pnode->m_vBranch.push_back(node);

		}

		//memcheck pnode->m_pITest = test->CloneTest();
		pnode->m_pITest = test;
// CTDIDTInducerAPDepthK
		m_iCurrentDepth--;
// CTDIDTInducerAPDepthK
		return pnode;
		
	}
// CTDIDTInducerAPDepthK
	m_iCurrentDepth--;
// CTDIDTInducerAPDepthK
	return NULL;	
}
//-CS-

bool CTDIDTCSInducer::DoDivision(deque<CDataObject*> &deqCI, ITest* test, long double &dMisCost)
{
	bool result=false;
	dMisCost=0;
	//podzialy
	vector<vector<unsigned> > vvDiv = test->GetSubSets(deqCI);
	
	//pobranie etykiety pierwszego zbioru
	deque<CDataObject*> subset;
	vector<unsigned> subIDs;
	double cost;
	IAttrValue* pIAV1=NULL;

	unsigned i=0;
	//pobieranie pierwszej etykiety
	while (pIAV1==NULL){
		subIDs = vvDiv[i];
		for(unsigned j=0; j<subIDs.size(); j++){
			subset.insert(subset.end(),deqCI[subIDs[j]]);
		}

		pIAV1=Category(subset,NULL,cost);
		i++;
	}
	dMisCost+=cost;
	/*//jeeli nie dokona sie podzialow zwroc false
	if (pIAV1==NULL){
		return false;
	}*/

	IAttrValue *pIAV2=NULL;

	//znalezienie kolejnych etykiet
	for(; i<vvDiv.size(); i++){
		deque<CDataObject*> subset;
		vector<unsigned> subIDs = vvDiv[i];		

		for(unsigned j=0; j<subIDs.size(); j++){
			subset.insert(subset.end(),deqCI[subIDs[j]]);
		}
		pIAV2=Category(subset,NULL,cost);

		//jezeli etykiety sie roznia ale druga nie jest NULL
		if (pIAV2!=NULL){
			dMisCost+=cost;
			if ((*pIAV1)!=(*pIAV2)) {
				result = true;
			}
		}
	}
	return result;
}

double CTDIDTCSInducer::GetMissclasificationCost(deque<CDataObject*> &deqCI, const IDataSet *trainingDataSet){
	if(m_bCostOfClassification){
		if(deqCI.size()>0){
			// Wektor par (klasa, koszt)
			vector<pair<IAttrValue*, double> > classCost;
			// Wyszukanie wszystkich klas
			for(unsigned int i=0;i<deqCI.size();i++){
				CDataObject *inst = deqCI[i];
				int x=0;
				for(unsigned int j=0;j<classCost.size();j++){
					IAttrValue *ia1=classCost[j].first;
					IAttrValue *ia2=inst->GetClass();
					if((*ia1)==(*ia2)){
						x=1;
						break;
					}
				}
				if(x==0){
					pair<IAttrValue*, double> p(inst->GetClass(),0);
					classCost.push_back(p);
				}
			}
			// Sprawdzenie jaki jest koszt klasyfikacji przy wyborze kazdej z klas
			// od razu znalezenie najlepszej klasy (czyli mininalny koszt)
			int minIndex = -1;
			double minCost = -1;
			for(size_t clID=0; clID<classCost.size(); clID++){
				IAttrValue *ia1=classCost[clID].first;
				for(unsigned int i=0;i<deqCI.size();i++){
					IAttrValue *ia2=deqCI[i]->GetClass();
					try{
						CNomAttr& predC = dynamic_cast<CNomAttr&>(*ia1);
						CNomAttr& trueC = dynamic_cast<CNomAttr&>(*ia2);
						classCost[clID].second += trainingDataSet->CostOfClassification(predC,trueC);
					}
					catch(bad_cast){
					}
					// Jezeli juz mamy wiekszy koszt niz min to nie ma co isc dalej
					// przerywamy
					if(minIndex != -1 && classCost[clID].second > minCost){
						break;
					}
				}
				if(minIndex == -1){
					minIndex = clID;
					minCost = classCost[clID].second;
				}else{
					if(classCost[clID].second < minCost){
						minIndex = clID;
						minCost = classCost[clID].second;
					}
				}
			}
			return classCost[minIndex].second;
		}else{
			return 0.0;
		}
	}
	else return 0.0;
}
