#ifndef __CTDIDTCSINDUCER__
#define __CTDIDTCSINDUCER__

#include "../../mlpcore/MLPDT_TD/TDIDTInducer.h"

/**
 * Inducer top-down uwzgledniajacy koszt blednej klasyfikacji oraz koszt pozyskania atrybutow.
 */
class CTDIDTCSInducer : public CTDIDTInducer{
public:
	CTDIDTCSInducer(void);
	virtual ~CTDIDTCSInducer(void);

	virtual ITest* PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);
	virtual bool SetParam(string sParamName, string sParamValue);
	void PreBuildTree(ITestContainer &tests, const IDataSet *trainingDataSet);
	/**
	* Przeciaona metoda dodatkowo zwracajca koszt bdnej klasyfikacji
	*/
	virtual IAttrValue* Category(deque<CDataObject*> &deqCI, IAttrValue *pIA, double &dCost);

//-CS-
	virtual IAttrValue* Category(const IDataSet* dataset, deque<CDataObject*> &deqCI, IAttrValue *pIA);
//-CS-

protected:

//-CS-
	/**
     * poziom drzewa na ktorym zostal dany atrybut pozyskany 
	 * w galezi aktualnie budowanej
	 * -1 - nie pozyskany
	 */
	vector<int> m_vAttrBranch;

	virtual CDTreeNode* BuildTree(deque<CDataObject*> &deqCI, ITestContainer &tests, IAttrValue *pIA, const IDataSet *trainingDataSet);
//-CS-

	/**czy zastosowanie testu da podzial na klasy
	*/
	bool DoDivision(deque<CDataObject*> &deqCI, ITest* test, long double &dMisCost);
	
	
	
	/**
	*/
	ITest* PickOutICF(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);
	ITest* PickOutMinCost(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *trainingDataSet);
	/**Zwraca koszt bdnej klasyfikacji zbioru obiektw
	*/

	double GetMissclasificationCost(deque<CDataObject*> &deqCI, const IDataSet *trainingDataSet);
};

#endif
