#include "TDIDTInducerOB.h"	
#include "../../mlpcore/MLPCommon/MLPStatistics.h"
#include <iomanip>

CTDIDTInducerOB::CTDIDTInducerOB(void){
	m_uPUF = 5;
	m_sSplit = "dipolar";
}

CTDIDTInducerOB::~CTDIDTInducerOB(void){
}

ITest* CTDIDTInducerOB::PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *dataset){

	// Jak jest osiagnieta maksymalna glebokosc drzewa to zwracamy NULL i robudowywanie
	// drzewa zostanie zatrzymane.
	if(m_iMaxDepth > -1 && m_iCurrentDepth >= m_iMaxDepth){
		return 0;
	}

	// Kiedy jest za malo przykladow, aby spalenic warunek unikania underfittingu
	if( !(m_uPUF<deqCI.size())){
		return NULL;
	}
	if(m_sSplit=="random"){
		return m_oblTestCreator.CreateRandObliqueTest(deqCI,m_pDataset->GetCurrentRealAttrCount(),m_uPUF);
	}
	if(m_sSplit=="evolutionary"){
		return m_EAoblTestCreator.CreateObliqueTest(deqCI,m_pDataset->GetCurrentRealAttrCount(),m_uPUF);
	}
	// Dipolowy wybor testu jest domyslny.
	return m_oblTestCreator.CreateObliqueTest(deqCI,m_pDataset->GetCurrentRealAttrCount(),m_uPUF);
}

void CTDIDTInducerOB::PreBuildTree(ITestContainer &tests, const IDataSet *trainingDataSet){
}

void CTDIDTInducerOB::PostBuildTree(ITestContainer &tests){
}

bool CTDIDTInducerOB::SetParam(string sParamName, string sParamValue){
	string::iterator i = sParamName.begin();
	while(i != sParamName.end()){
		*i = tolower(*i);
		++i;
	}
	i = sParamValue.begin();
	while(i != sParamValue.end()){
		*i = tolower(*i);
		++i;
	}

	if(sParamName=="split"){
		if(sParamValue=="random" || sParamValue=="evolutionary" ||
		   sParamValue=="dipolar"){
			m_sSplit = sParamValue;
			return true;
		}else{
			return false;
		}
	}
	if(sParamName=="prevention underfitting factor" || sParamName=="preventionunderfittingfactor"){
		m_uPUF = atoi(sParamValue.c_str());
		return true;
	}

	if(ITDIDTInducer::SetParam(sParamName,sParamValue)) return true;

	return false;
}

bool CTDIDTInducerOB::SetSubParam(string sParentParamName, string sSubParamName, string sSubParamValue){
	string::iterator i = sSubParamName.begin();
	while(i != sSubParamName.end()){
		*i = tolower(*i);
		++i;
	}
	i = sSubParamValue.begin();
	while(i != sSubParamValue.end()){
		*i = tolower(*i);
		++i;
	}
	i = sParentParamName.begin();
	while(i != sParentParamName.end()){
		*i = tolower(*i);
		++i;
	}

	if(sParentParamName=="split" && m_sSplit=="evolutionary"){
		if(m_EAoblTestCreator.SetParam(sSubParamName,sSubParamValue)){
			return true;
		}
	}
	
	return false;
}

void CTDIDTInducerOB::PrintParamsXML(ostream &ostr, int nsp){
	ITDIDTInducer::PrintParamsXML(ostr,nsp);
	ostr.fill(' ');
	ostr<<setw(nsp)<<" "<<"<MLPParam Name=\"split\" Value=\"evolutionary\" >"<<endl;
	m_EAoblTestCreator.PrintSubParamsXML(ostr,nsp+2);
	ostr<<setw(nsp)<<" "<<"</MLPParam>"<<endl;
	ostr<<setw(nsp)<<" "<<"<MLPParam Name=\"preventionunderfittingfactor\" Value=\"5\" />"<<endl;
	ostr.fill(' ');
}

vector<string> CTDIDTInducerOB::GetSubOptions(string sParamName, string sParamValue) const{
vector<string> res;
	if(sParamName=="split" && sParamValue=="evolutionary"){
		res = m_EAoblTestCreator.GetParams();
	}
	return res;
}

vector<string> CTDIDTInducerOB::GetParams() const{
vector<string> res;
stringstream ss;

	res = ITDIDTInducer::GetParams();
	res.push_back("split");
	res.push_back(m_sSplit);
	res.push_back("preventionunderfittingfactor");
	ss.str(""); ss<<m_uPUF;
	res.push_back(ss.str());
	
	return res;
}

bool CTDIDTInducerOB::StopCondition(deque<CDataObject*> &deqCI, size_t iTestNum, void *pVoid){
	if(deqCI.size() >= m_uMinimunItems /*&& iTestNum>0 - to jest w klasie podstawowej*/){
		IAttrValue *pIA1 = deqCI[0]->GetClass();
		for(unsigned i=1; i<deqCI.size(); i++){
			IAttrValue *pIA2 = deqCI[i]->GetClass();
			if( ! ((*pIA1) == (*pIA2)) ){
				if(CMLPStatistics::Event((int)(100.0*m_dRandomStop))){
					return true;
				}
				return false;
			}
		}
		return true;
	}else
		return true;
}
