#ifndef __CTDIDTINDUCEROB__
#define __CTDIDTINDUCEROB__

#include "../../mlpcore/MLPDT/ITDIDTInducer.h"
#include "EAObliqueTestCreator.h"

/**
 * @author Marek Grzes'
 */ 
class CTDIDTInducerOB: public ITDIDTInducer{
public:
	virtual vector<string> GetParams() const;
	virtual vector<string> GetSubOptions(string sParamName, string sParamValue) const;
	virtual bool SetParam(string sParamName, string sParamValue);
	virtual bool SetSubParam(string sParentParamName, string sSubParamName, string sSubParamValue);
	virtual void PrintParamsXML(ostream &ostr, int nsp);
	virtual string GetName(){
		return "TDIDT Oblique";
	}

	CTDIDTInducerOB(void);
	virtual ~CTDIDTInducerOB(void);

protected:
	CObliqueTestCreator	m_oblTestCreator;
	CEAObliqueTestCreator	m_EAoblTestCreator;

	string	m_sSplit;

	/** prevention underfitting factor
	 */
	unsigned	m_uPUF;

	virtual ITest* PickOutTest(deque<CDataObject*> &deqCI, ITestContainer &tests, const IDataSet *dataset);
	virtual void PreBuildTree(ITestContainer &tests, const IDataSet *trainingDataSet);
	virtual void PostBuildTree(ITestContainer &tests);

	/** Implementacja tej funkcji poniewaz jej implementacja z klasy bazowej,
	 * przyjmuje, ze warunek stopu zachodzi, kiedy nie ma juz testow train test, czyli
	 * parametr iTestNum==0. W tej klasie nie ma testow trenujacych, dlatego trzeba
	 * zmodyfikowac ta funkcje.
	 */
	virtual bool StopCondition(deque<CDataObject*> &deqCI, size_t iTestNum, void *pVoid=NULL);

};

#endif

