#ifndef __CCHROMOSOME__
#define __CCHROMOSOME__

#include <vector> 
#include <fstream>
#include <cmath>

#include "ChromosomeDesc.h"

using namespace std;

class CChromosome{
private:
	/**
	* 
	*/
	CChromosomeDesc *m_pChrDesc;
	/**
	* Ustawienie bitw na losowe wartoci
	*/
	void Randomize();
	/**
	* Zamiana liczby reprezentujcej warto binarn na warto kodu greya
	*/
	int BinaryToGrey(int value);
	/**
	* Zamiana liczby reprezentujcej warto kodu greya na warto binarn
	*/
	int GreyToBinary(int value);
	/**
	* Zamienia bity na odpowiedniej pozycji
	*/
	void Change(CChromosome* pChr, int pos);
public:
	/**
	* Wektor zawierajcy cig bitw
	*/
	vector<bool> m_vString; 
	/**
	* Dopasowanie
	*/
	long double m_ldFitness;
	/**
	* Konstruktor domylny
	*/
	CChromosome(CChromosomeDesc *pChrdesc);
	/**
	* Konstruktor ustawiejcy odpowieni ilo cech
	*/
	CChromosome(CChromosome *pChr);
	/**
	* Wrzuca chromosom w postaci ciagu 0,1 do strumienia
	*/
	void ToString(ostream *ostr);
	/**
	* Zwraca liczbe cakowit
	*/
	vector<long double> GetFonotype();
	/**
	* Mutacja pojedynczego chromosomu
	*/
	void Mutate(double mutrate);
	/**
	* Krzyowanie jednopunktowe
	*/
	void Crossover(CChromosome* pChr, int end);
	/**
	* Krzyowanie dwupunktowe
	*/
	void Crossover(CChromosome* pChr, int start, int end);

	~CChromosome(void);
	
};

#endif
