#include "GenAlgTest.h"

CGenAlgTest::CGenAlgTest(void):CGeneticAlgorithm(){
}

CGenAlgTest::~CGenAlgTest(void){
}

void CGenAlgTest::SetParams(){
	m_pChrDesc->m_iNBits=10;
	m_pChrDesc->m_iNFeatures=1;
	m_pChrDesc->m_iChromosomeSize=m_pChrDesc->m_iNFeatures*m_pChrDesc->m_iNBits;
	minValue=-10;
	maxValue=10;
}

void CGenAlgTest::SetFitness(CPopulation *pPop){
	deque<CChromosome*> deqChr=pPop->m_deqPopulation;
	for (unsigned int i=0;i<deqChr.size();i++){
		double value=minValue+((deqChr[i]->GetFonotype())[0])*(maxValue-minValue);
		deqChr[i]->m_ldFitness=200-abs(2*value*value);
	}
}

double CGenAlgTest::Experiment(){
	SetParams();
	CreatePopulation();
	cout<<"najlepszy wynik przed eksperymentem: "<< 200-m_pPopulation->GetFittest()->m_ldFitness<<endl;
	Run();
	return (200-m_pPopulation->GetFittest()->m_ldFitness);
}
