#include "GeneticAlgorithm.h"
#include <cstdlib>

CGeneticAlgorithm::CGeneticAlgorithm(){
	srand((unsigned)time( NULL ) );
	m_iPopulationSize=40;
	m_iLoop=1000;
	m_pPopDesc=new CPopDesc();
	m_pChrDesc=new CChromosomeDesc();
	m_pPopulation=NULL;
	m_pNewPopulation=NULL;
}

CGeneticAlgorithm::~CGeneticAlgorithm(){
	if(m_pPopDesc!=NULL){
		delete m_pPopDesc;
	}
	if(m_pChrDesc!=NULL){
		delete m_pChrDesc;
	}

	if(m_pPopulation!=NULL){
		delete m_pPopulation;
	}

	if(m_pNewPopulation!=NULL){
		delete m_pNewPopulation;
	}
}

void CGeneticAlgorithm::CreatePopulation(){
	//stworzenie populacji glownej i potomnej
	m_pNewPopulation=new CPopulation(m_pChrDesc,m_pPopDesc,m_iPopulationSize);
	m_pPopulation=new CPopulation(m_pChrDesc,m_pPopDesc,m_iPopulationSize);
	SetFitness(m_pPopulation);
	SetFitness(m_pNewPopulation);
}

void CGeneticAlgorithm::Run(){
	CPopulation *tmp;
	for (int j=0;j<m_iPopulationSize/2;j++){
		for (int i=0;i<m_iLoop;i++){
			if (((double)rand()/(double)RAND_MAX)<m_pPopDesc->m_dCrossoverRate){
				vector<CChromosome*> vParents=m_pPopulation->GetParents();
				vector<CChromosome*> vOffspring=m_pPopulation->Crossover(vParents);
				m_pNewPopulation->Replace(vOffspring[0]);
				m_pNewPopulation->Replace(vOffspring[1]);
				vParents.clear();
				vOffspring.clear();
			}
			m_pNewPopulation->Mutate();
		}
		tmp=m_pNewPopulation;
		m_pNewPopulation=m_pPopulation;
		m_pPopulation=tmp;

		SetFitness(m_pPopulation);
	}
	cout<<endl;
}
