#ifndef __CGENETICALGORITHM__
#define __CGENETICALGORITHM__

#include "Population.h"
#include "PopDesc.h"
#include "ChromosomeDesc.h"

#include <ctime>
#include <iostream>

class CGeneticAlgorithm{
protected:
	/**
	* Populacja osobnikw
	*/
	CPopulation *m_pPopulation;
	/**
	* Populacja osobnikw potomnych
	*/
	CPopulation *m_pNewPopulation;
	/**
	* Waciwoci populacji
	*/
	CPopDesc *m_pPopDesc;
	/**
	* Waciwoci chromosomu
	*/
	CChromosomeDesc *m_pChrDesc;
	virtual void SetParams()=0;
public:
	/**
	* Wielko populacji
	*/
	int m_iPopulationSize;
	/**
	* Ilosc wykona gwnej ptli
	*/
	int m_iLoop;
	/**
	* Kostruktor domyslny
	*/
	CGeneticAlgorithm();
	/**
	* Destruktor
	*/
	virtual ~CGeneticAlgorithm();
	/**
	* Stworzenie populacji gwnej i potomnej na podstawie ustawionych 
	* wczeniej parametrw
	*/
	void CreatePopulation(void);
	/**
	* Uruchomienie aglorytmu ewolucyjnego
	*/
	void Run(void);
	/**
	* Obliczenie dostosowania kadego osobnika
	*/
	virtual void SetFitness(CPopulation* pPop)=0;
};

#endif
