#ifndef __CICET__
#define __CICET__

#include "GeneticAlgorithm.h"
#include "../../mlpcore/MLPDT/DTClassifier.h"
#include "../MLPDT_TD_AP/TDIDTCSInducer.h"
#include "../MLPDT/ICF.h"
#include "../../mlpcore/MLPDataset/TempDataSet.h"

class CICET : public CGeneticAlgorithm, public IInducer{
protected:
	virtual void SetFitness(CPopulation *pPop);
	/**
	* Ustawienie parametrw populacji na podstawie datasetu
	*/
	virtual void SetParams();	

	/**
	* Maksymalny koszt atrubutu podczas eksperymentu
	*/
	double m_dMaxCost;
public:
	
	virtual string GetName(){
		return string("MLPDT_ICET");
	}

	IClassifier* ActualTrain(const IDataSet* pDS);
	/**
	* Konstruktor
	*/
	CICET();
	/**
	* Destruktor
	*/
	~CICET();
	/**
	* Metoda zwraca koszt klasyfikacji
	*/
	double GetCostOfClassification(IClassifier *pIC,const IDataSet *pIDS);
};

#endif
